// Game.cpp: implementation of the CGame class.
//
//////////////////////////////////////////////////////////////////////

#include "Game.h"
#include "PLD3DEngine\D3DEngine.h"
#include "Ship.h"
//#include "Stars.cpp"

CD3DEngine Engine;	
extern HWND hWnd;	// from main.cpp

#define NUM_MODELS 7			// Number of models in scene.
#define NUM_STARS 50			// Number of stars in scene.
#define SCREEN_LEFT_PLN -200	// Left border of game screen plane
#define SCREEN_WIDE_PLN 1000	// Wide of game screen plane
#define SCREEN_TOP_PLN 200
#define SCREEN_BOT_PLN -200
#define NUM_TYPE_PLANETS 2

CShip Ship;

CVector Star[NUM_STARS];
CVector Planet;
int Planet_type;
float Planet_angle;
float backfire;
float land_x = 0.0f;

float GS = 0.0f;



//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CGame::CGame()
{
	bDebugInfo = FALSE;
	bPause = FALSE;
	bSlowRender = FALSE;
		//TRUE;
	bMenu = TRUE;
	ActiveMenu = 0;
	bCredits = FALSE;
	
	//Engine.Screen.Width=1280;
	//Engine.Screen.Height=1024;
	Engine.Screen.FullScreen=TRUE;
	Engine.Screen.Width=1024;
	Engine.Screen.Height=768;
	
}

CGame::~CGame()
{

}

// Func of approximate compare //
bool Approx (float test_num, float res_num, float approx) {

	if ((test_num > res_num - approx)&&(test_num < res_num + approx)) return true;
	else return false;
}

void StarBack()
{
	// Generate stars //
	for(int i=0;i<NUM_STARS;i++) {
		Star[i].x=rand()%SCREEN_WIDE_PLN+SCREEN_LEFT_PLN;
		Star[i].y=rand()%600-300;
		Star[i].z=rand()%200-100;
	}
}

/*void Fire()
{
	if (!Ship.bFire) {
		Ship.bFire=true;
		Ship.fire_loop = 1000;
	} else {
		
	}

}*/


void CreatePlanet()
{
	Planet.x = rand()%SCREEN_WIDE_PLN+SCREEN_WIDE_PLN;//+SCREEN_LEFT_PLN;
	Planet.y=rand()%600-300;
	Planet.z=rand()%300+100;
	Planet_type=rand()%2;
}


void CGame::LoadData()
{
/*	FILE *filein;
	char oneline[255], str1[255]="",str2[255]="";
	float tmp_v1=0,tmp_v2=0,tmp_v3=0;
	float tmp_cf=0;
	float tmp_p=0;
	float tmp_np=0;
	int n;


	if ((filein = fopen("data2.txt", "rt+")) == NULL)
	{
		MessageBox(NULL,"ERROR: NO DATA FILE!","OSHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
	} else {
		
			
		// COS(FI) //
		FindStr(filein,"[cos(fi)]");
		sscanf(oneline, "%f", &tmp_cf); ReadStr(filein, oneline); Cos_fi = tmp_cf;
		//	MessageBox(NULL,oneline,"OSHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);

		// SECTIONS & PRIBORS //
		for (int s=0; s<NUM_SECTIONS; s++){
			n = s + 1;
			// Section.Num_pribors //
			//ReadStr(filein, oneline); ReadStr(filein, oneline);
			
			sprintf(str1,"[Section%d]",n);
			//	MessageBox(NULL,str1,"OSHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
			FindStr(filein,str1);//"[Section");
			sprintf(str2,"[NUM_PRIBORS%d]",n);
			//	MessageBox(NULL,str2,"OSHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
			FindStr(filein,str2);

			ReadStr(filein, oneline);
			sscanf(oneline, "%d", &tmp_np); Section[s].Num_pribors = tmp_np;
			//	MessageBox(NULL,oneline,"Num_pribors",MB_OK | MB_ICONINFORMATION);
			
			for (int p=0; p<Section[s].Num_pribors; p++){
				// Pribor[p] = //
				ReadStr(filein, oneline); ReadStr(filein, oneline);
				sscanf(oneline, "%f", &tmp_p); Section[s].Pribor[p].volume = tmp_p; 
			}
		}
		fclose(filein);
	};
	//	if (Pribor[2].volume<0) Calc=1; 
	*/
}





void CGame::PressKey()
{
	if (Engine.Keyboard.Key[VK_ESCAPE]) SendMessage(hWnd,WM_CLOSE,0,0);
	if (Engine.Keyboard.Key[VK_UP])		if (Engine.XObject[0].Position.y<SCREEN_TOP_PLN) Ship.Angle+=GS/4.0f; else Ship.Angle=0;
	if (Engine.Keyboard.Key[VK_DOWN])	if (Engine.XObject[0].Position.y>SCREEN_BOT_PLN) Ship.Angle-=GS/4.0f; else Ship.Angle=0;
	//Ship.Angle=0;
	if (Engine.Keyboard.Key[VK_RIGHT])	if (Ship.Velocity<Ship.MaxVelocity) Ship.Velocity+=0.01f * GS;
	if (Engine.Keyboard.Key[VK_LEFT])	if (Ship.Velocity>Ship.MinVelocity) Ship.Velocity-=0.01f * GS;

	if (Engine.Keyboard.Key[VK_SPACE]) { if (!Ship.bFire) Ship.bullet = CVector(50,Engine.XObject[0].Position.y-10,0); Ship.Fire();}

}


void CGame::Init()
{
	// GAME NEW //
	Engine.AddXObjects(NUM_MODELS);
	Engine.XObject[0].Load("Models/letM13c4.x");
	Engine.XObject[0].SetOrientation(CVector(0,-90,0));
	Engine.XObject[0].SetPosition(CVector(0,0,0));
	/*Engine.XObject[0].SetTextureMode(1,PL_TEX_SPHERE,PL_D3DTOP_ADDSIGNED2X);
	Engine.XObject[0].LoadSecondTexture("gal4.jpg");*/
	//Engine.XObject[0].Visible=FALSE;

	Engine.XObject[1].Load("Models/star1c.x");
	Engine.XObject[1].SetOrientation(CVector(0,0,0));
	Engine.XObject[1].SetPosition(CVector(70,0,0));

	Engine.XObject[2].Load("Models/planet1c.x");
	Engine.XObject[2].SetPosition(CVector(950,0,0));
	/*Engine.XObject[2].SetTextureMode(1,PL_TEX_SPHERE,PL_D3DTOP_ADDSIGNED2X);
	Engine.XObject[2].LoadSecondTexture("second.bmp");*/

	Engine.XObject[3].Load("Models/planet2c.x");
	Engine.XObject[3].SetPosition(CVector(1050,0,0));
	/*Engine.XObject[3].SetTextureMode(1,PL_TEX_SPHERE,PL_D3DTOP_ADDSIGNED2X);
	Engine.XObject[3].LoadSecondTexture("second.bmp");*/

	Engine.XObject[4].Load("Models/letout.x");
	Engine.XObject[4].SetOrientation(CVector(0,-90,0));
	Engine.XObject[4].SetPosition(CVector(-40,0,0));

	Engine.XObject[5].Load("Models/fire1.x");
	Engine.XObject[5].SetOrientation(CVector(0,-90,0));
	Engine.XObject[5].SetPosition(CVector(50,-10,0));

	Engine.XObject[6].Load("Models/land001.x");
	Engine.XObject[6].SetOrientation(CVector(0,-90,0));
	Engine.XObject[6].SetPosition(CVector(-50,50,0));

	Engine.InitFonts(3);
	Engine.AddTxtBlocks(6);
	Engine.TxtBlock[0].Set(0,10,50,D3DCOLOR_ARGB(100,10,30,110),"!");
	//Engine.ChangeFont(0,"Arial",5);

	Engine.Camera.SetWide(70.0f);
	/*Engine.Camera.SetPosition(CVector(-250,0,-400));
	Engine.Camera.SetOrientation(CVector(0,60,0));*/
	Engine.Camera.SetPosition(CVector(300,0,-500));
	Engine.Camera.SetOrientation(CVector(0,0,0));
	Engine.Camera.SetDistanse(1, 800);

	LoadData();
	StarBack();
	CreatePlanet();
	Engine.Fps.SetPoint();

}

void CGame::DrawAll()
{
	// Draw VM's //
	for(int i=0;i<NUM_MODELS;i++){
		if (Engine.XObject[i].Visible) Engine.XObject[i].Draw(NULL);
	}
	
	// DRAW STARS //
	for(int s=0;s<NUM_STARS;s++){
		Engine.XObject[1].SetPosition(Star[s]);
		Engine.XObject[1].Draw(NULL);
	}
	
	// DRAW PLANET //
	Engine.XObject[2+Planet_type].SetPosition(Planet);
	Engine.XObject[2+Planet_type].SetOrientation(CVector(0,Planet_angle,0));

	// DRAW LAND 00 //
	if (Engine.XObject[6].Visible) {
		Engine.XObject[6].SetPosition(CVector(land_x,0,0));
		Engine.XObject[6].Draw(NULL);
		Engine.XObject[6].SetPosition(CVector(land_x+1600,0,0));
		Engine.XObject[6].Draw(NULL);
	}

}


void CGame::Move(float SPEED)
{
	// *** CALCULATE SPEED *** //
	GS = 900.0f / Engine.Fps.framerate; //1000.0f;
	if (GS>150.0f) GS = 1.0f;

	
	// MOVE STARS //
	for(int s=0;s<NUM_STARS;s++){
		Star[s]-=CVector((float)Ship.Velocity / 10.0f,0,0); //(GS*10.0f), 0, 0);
		if (Star[s].x<SCREEN_LEFT_PLN) Star[s].x+=SCREEN_WIDE_PLN;
	}

	// MOVE PLANET //
	//if (Planet_angle<360.0f) Planet_angle+=0.1f; else Planet_angle=0;
	Planet-=CVector((float)Ship.Velocity / (GS*20.0f), 0, 0);
	if (Planet.x<SCREEN_LEFT_PLN*3) CreatePlanet(); //Planet.x+=SCREEN_WIDE_PLN;
	
	
	// MOVE SHIP //
	if (Ship.Angle>0) Ship.Angle-=0.2f*GS;
	if (Ship.Angle<0) Ship.Angle+=0.2f*GS;
	Engine.XObject[0].Angle.z=Ship.Angle; // 10.0f;//(GS*10.0f);
	Engine.XObject[0].Position.y += Ship.Angle / 5;//(GS*5.0f);
	// backOUT //
	if (backfire>-100.0f) backfire-=(Ship.Velocity / GS); else backfire=0.0f;
	Engine.XObject[4].Position.x = -40+backfire;
	Engine.XObject[4].Position.y = Engine.XObject[0].Position.y;

	// MOVE FIRE //
	Ship.FireGo(5.0f*GS);
	Engine.XObject[5].Position = Ship.bullet;
	if (Ship.bFire) Engine.XObject[5].Visible=TRUE; else Engine.XObject[5].Visible=FALSE;

	// MOVE LAND //
	land_x -= GS / 10.0f;
	//Engine.XObject[6].Position.x = land_x; //-= GS / 10.0f;
	if (land_x < -2100) land_x=0;

}


void CGame::Loop()
{
	//MessageBox(NULL,"ERROR: CP 3","OSHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
	
	char nStats[64];
	
	// LOGIC & MOVE //
	Move(1.0f);
	// SCAN KEY //
	PressKey();

	if (Engine.Fps.GetPoint()>0.0001f){
		// SCAN KEY //
		//PressKey();

		// LOGIC & MOVE //
		//Move(1.0f);


		// Time Point //
		Engine.Fps.SetPoint();
	}

	// TEXT //
	Engine.TxtBlock[1].Set(1, 10,10,D3DCOLOR_XRGB(200,190,50),itoa(Engine.Fps.fps,nStats,10));//nStats);
	Engine.Fps.GetPoint();
	/*sprintf(nStats, "mx=%d my=%d ts=%f gt=%f",Engine.Mouse.position.x,Engine.Mouse.position.y, Engine.Fps.set_point, Engine.Fps.time_elapsed);//Engine.Fps.gt);//set_point);
	Engine.TxtBlock[5].Set(0, 10,80,D3DCOLOR_XRGB(200,190,50),nStats);*/
	
	sprintf(nStats, " Vel= %0.2f; Angle= %0.2f", Ship.Velocity, Ship.Angle);
	Engine.TxtBlock[0].Set(0, 10,50,D3DCOLOR_XRGB(200,190,50),nStats);//nStats);

	sprintf(nStats, "X= %0.2f; Y= %0.2f; Z= %0.2f", Engine.XObject[0].Position.x,Engine.XObject[0].Position.y,Engine.XObject[0].Position.z);
	Engine.TxtBlock[2].Set(1, 10,80,D3DCOLOR_XRGB(100,200,100), nStats); // itoa(Pribor[0].limit,nStats,10));
	sprintf(nStats, "GS=%0.3f", GS);
	Engine.TxtBlock[3].Set(1, 10,110,D3DCOLOR_XRGB(200,50,0), nStats); // itoa(Pribor[0].limit,nStats,10));
	/*sprintf(nStats, "      %0.2f", Pribor[2].volume_vis);
	Engine.TxtBlock[4].Set(1, 664,332,D3DCOLOR_XRGB(0,0,0), nStats); // itoa(Pribor[0].limit,nStats,10));
*/	
	
	// LOGIC //
	// BUTTONS LIMIT SET //
	int step = 30;
	int Pr_lx[2];
	Pr_lx[0] = 105;
	Pr_lx[1] = 355;
	
/*	if (Engine.Mouse.left_button==TRUE) {
		//      //
		for (int p=0;p<2;p++){
			for (int b=0;b<5;b++){
				if (Approx(Engine.Mouse.position.x, Pr_lx[p]+step*b, 7)) {
					Pribor[p].limit=b;
				}
			}
			if (p==1) {
				if (Approx(Engine.Mouse.position.x, Pr_lx[p]+step*5, 8)) {
					Pribor[p].limit=5;
				}
			}
		}
		//      //
		if (Engine.Fps.GetPoint()>0.3f){
		if (Approx(Engine.Mouse.position.x, 50, 7)) {
			Pribor[0].swtch=!Pribor[0].swtch;
			Pribor[1].swtch=!Pribor[1].swtch;
			Engine.Fps.SetPoint();

		}
		if (Approx(Engine.Mouse.position.x, 315, 7)) {
			Pribor[0].swtch=!Pribor[0].swtch;
			Pribor[1].swtch=!Pribor[1].swtch;
			Engine.Fps.SetPoint();
		}
		}
		
		//    ""
		if (Approx(Engine.Mouse.position.x, 695, 80)){
			if (Approx(Engine.Mouse.position.y, 440, 35)){
				//bRefresh=TRUE;
				LoadData();
			}
		}

	}

	
	// LIMIT //
	for(int p=0;p<2;p++){
		if (Pribor[p].volume>Real_limits[p][Pribor[p].limit]) Pribor[p].volume_vis=Real_limits[p][Pribor[p].limit];
		else Pribor[p].volume_vis=Pribor[p].volume;
	}
	Pribor[2].volume_vis=Pribor[2].volume;
	
	
	// CALCULATE //
	if (Calc==1){ 
		if (Pribor[0].swtch==0){
			Pribor[2].volume=Pribor[0].volume * Pribor[1].volume;
		} else {
			Pribor[2].volume=Pribor[0].volume * Pribor[1].volume * Cos_fi;
		}
	}
*/	

	// DRAW //
	Engine.Fps.Calculate();
	Engine.StartDraw();
	DrawAll();
	Engine.Render();
	Engine.EndDraw();


	

}