unit g_Game;

interface
uses
  HGE,HGEFont,HGESprite,HGEParticle,sysutils,
  g_Types,g_LevelManager,g_cfg,g_Options,
  g_utils,g_gui,g_Hint,g_Loading,g_Map,g_pchar,g_camera,g_Bonus,g_Player,
  g_monster_fly,g_monster_eye,g_monster_nlo,g_monster_bee,g_boss_BigHead;

procedure World_Create();
procedure World_Init();
procedure World_Control;
procedure World_Update(const delta : single);
procedure World_Draw();
procedure World_Destroy();
implementation
uses
  g_main, Classes;

procedure World_Create();
begin
  Loading.Process('Create world...');
  //Loading.TextPosX := 32;
  //SetPChar( Loading.Text2, ' !    ,    .           .    !');
  //FntMan.WordTransfer(Loading.Fnt,Loading.Text2,320);
  with Game do begin
    Music := _Hge.Stream_Load(Cfg_ReadStr('data\cfg\game.cfg','MUSIC','data\music\Slava - Synthez.mp3'));
    GameplayColorCount := 7;
    GameplayColorAll[0] := $ff55ccff;
    GameplayColorAll[1] := $ff55ffcc;                                          // blue
    GameplayColorAll[2] := $ffffcc55;                                          // green
    GameplayColorAll[3] := $ffccff55;                                          // yelow
    GameplayColorAll[4] := $ffcc55ff;                                          //   
    GameplayColorAll[5] := $ffff55cc;                                          // red
    GameplayColorAll[6] := $ffffffff;                                          // violet
    TexParticle := _HGE.Texture_Load(Cfg_ReadStr('data\cfg\game.cfg','TEXTURE_PARTICLE_BALL','particles.png'));
    Pause := false;
  end;

  Map := TMap.Create;
  //BonusManager := TBonusManager.Create;
  Player := TPlayer.create;
  Monsters_FLY := TMonsterFLYManager.Create;
  Monsters_EYE := TMonsterEYEManager.Create;
  Monsters_NLO := TMonsterNLOManager.Create;
  Monsters_BEE := TMonsterBEEManager.Create;
  Boss_BigHead := TBoss_BigHeadManager.Create;
end;

procedure World_Init();
begin
  Loading.Process('Game settings...');
  Profile.Init;
  Loading.Process('Init objects...');
  ParticleManager.KillAll;
  //BonusManager.Init;
  Game.Channel.Resume;
  GUI.Init;
  Player.Init;
  Monsters_FLY.Init;
  Monsters_EYE.Init;
  Monsters_NLO.Init;
  Monsters_BEE.Init;
  Boss_BigHead.Init;
  _HGE.Input_SetMousePos(SCR_CENTER_W,SCR_CENTER_H);
  //Loading.Process('  ');
end;

procedure World_Control;
var
  X,Y : single;
begin
  if _HGE.Input_KeyDown(HGEK_P) then
  if Game.State=gsGame then Game.Pause := not Game.Pause
  else
  else
    if (Game.State=gsGame)then begin
    if ((_HGE.Input_GetKeyState(HGEK_LBUTTON))or(_HGE.Input_GetKeyState(HGEK_SPACE))) then begin
      player.GunMini.inShot := true;
      player.GunRocket.inShot := true;
      player.GunVoice.inShot := true;
    end;

    _HGE.Input_GetMousePos(X,Y);
  if X-SCR_CENTER_W < 0 then begin
    _HGE.Input_SetMousePos(SCR_CENTER_W-0,Y);
    Player.Left;
  end else
  if X-SCR_CENTER_W > 0 then begin
    _HGE.Input_SetMousePos(SCR_CENTER_W+0,Y);
    Player.Right;
  end;
  if Y-SCR_CENTER_H <0 then begin
    _HGE.Input_SetMousePos(X,SCR_CENTER_H-0);
    Player.pressGas;
  end else
  if Y-SCR_CENTER_H > 0 then begin
    _HGE.Input_SetMousePos(X,SCR_CENTER_H+0);
    Player.pressBreak;
  end;
  if _HGE.Input_GetKeyState(HGEK_Up) then Player.pressGas;
  if _HGE.Input_GetKeyState(HGEK_DOWN) then Player.pressBreak;
  if _HGE.Input_GetKeyState(HGEK_RIGHT) then Player.Right;
  if _HGE.Input_GetKeyState(HGEK_LEFT) then Player.Left;
    {if _HGE.Input_KeyDown(HGEK_UP) then
      if Player.level < Player.MaxLevel then inc(Player.level);
    if _HGE.Input_KeyDown(HGEK_Down) then
      if Player.level > 1 then dec(Player.level);}
  end;
end;

procedure World_Update(const delta : single);
begin
  //BonusManager.Update(delta);
  Map.Update(delta);
  //

  //if _HGE.Input_GetKeyState(HGEK_SPACE) then LaunchBomb;


  {if _HGE.Input_GetKeyState(HGEK_SPACE) then Monsters_FLY.AddMonster(random(WND_WIDTH),0);
  if _HGE.Input_GetKeyState(HGEK_SPACE) then Monsters_EYE.AddMonster(random(WND_WIDTH),0);
  if _HGE.Input_GetKeyState(HGEK_SPACE) then Monsters_NLO.AddMonster(random(WND_WIDTH),0);}
  Player.Update(delta);
  Monsters_FLY.Update(delta);
  Monsters_EYE.Update(delta);
  Monsters_NLO.Update(delta);
  Monsters_BEE.Update(delta);
  Boss_BigHead.Update(delta);
  GUI.Hint.Update(delta);
  GUI.GamePlayHint.Update(delta);
  GUI.HintLevelName.Update(delta);
  Profile.Update;
end;

procedure World_Draw();
begin
  //Camera.View;
  //Camera.Reset;
  Map.Render;
  ParticleManager.Render;
  //BonusManager.Render;
  Map.UpLayerRender;
  Player.Render;
  Monsters_FLY.Render;
  Monsters_EYE.Render;
  Monsters_NLO.Render;
  Monsters_BEE.Render;
  Boss_BigHead.Render;
  GUI.Hint.Draw;
  GUI.GameRender;
end;

procedure World_Destroy();
begin
  Map.Destroy;
  GUI.Hint.Destroy;
  GUI.GamePlayHint.Destroy;
  GUI.HintLevelName.Destroy;
  ParticleManager := nil;
  LevelManager.Destroy;
  Player.Destroy;
  Monsters_FLY.Free;
  Monsters_EYE.Free;
  Monsters_NLO.Free;
  Monsters_BEE.Free;
  //BonusManager.Destroy;
end;

end.
