unit g_Hint;

interface
uses
  Classes,
  g_Types,HGEFont;

type
  THintItem = class
    X,Y : single;
    Color : Cardinal;
    Time : single;
    Text : string;
  end;

  THint = class
    List : TList;
    Delay : single;                                                       //   
    Spd : Cardinal;
    Snd : integer;
    Fnt : IHGEFont;
    SpdX,SpdY : single;
    levelling : byte;
    constructor Create(fileName : string);
    destructor Destroy;
    procedure Clear;
    procedure Init;
    procedure Add(_X,_Y : single;_text : string; _Color : Cardinal);
    procedure Update(const delta : single);
    procedure Draw;
  end;

implementation

constructor THint.Create(fileName : string);
begin
  inherited Create;
  List := TList.Create;
  Fnt := THGEFont.Create(FileName);
end;

procedure THint.Clear;
var i : word;
begin
  i := 0;
  while i < List.Count  do begin
    THintItem(List.Items[i]).Free;
    inc(i);
  end;
  List.Clear;
end;

destructor THint.Destroy;
var i : word;
begin
  for I := List.Count - 1 downto 0 do
    THintItem(List.Items[i]).Free;
  List.Clear;
  List.Destroy;
  inherited;
end;

procedure THint.Init;
begin
  List.Clear;
  List.Add(THintItem.Create);
  Delay := 0.5;
  Spd := $05000000;
  SpdX := 0;
  SpdY := -0.1;
  levelling := 0;
end;

procedure THint.Add(_X,_Y : single;_text: string; _Color : Cardinal);
var ID : word;
begin
   ID := List.Add(THintItem.Create);
   with THintItem(List.Items[ID]) do begin
     Text := _text;
     X := _X;
     Y := _Y;
     Time := 0;
     Color := _Color;
   end;
end;

procedure THint.Update(const delta : single);
var i : word;
begin
  i := 0;
  while i < List.Count do begin
    with THintItem(List.Items[i]) do begin
      Time := Time + delta;
      X := X + SpdX;
      Y := Y + SpdY;
      if Time >= Delay then
      if Color > Spd then begin
        Color := Color-Spd;
      end else List.Delete(i);
    end;
    inc(i);
  end;
end;

//----------------------------------------------------------------------------
// Game hint draw
//----------------------------------------------------------------------------
procedure THint.Draw;
var i : word;
begin
  i := 0;
  while i < List.Count do begin
    with THintItem(List.Items[i]) do begin
       Fnt.SetColor(Color);
       Fnt.PrintF(X,Y,levelling,'%s',[Text]);
    end;
    inc(i);
  end;
end;

end.
