unit g_Loading;

interface
uses
  Windows,HGE,HGEFont,HGESprite,
  g_Types;

type
  TLoadingManager = class
    Tex : ITexture;
    Spr : IHGESprite;
    Text  : string;
    Text2 : pchar;
    TextPosX,TextPosY : word;
    Color : array [0..3] of single;
    Fnt : IHGEFont;
  public
    Constructor Create;
    procedure SetTexture(FileName : AnsiString);
    procedure Process(str : string = '');
    procedure WaitPressAnyKey;
  end;

var
  Loading : TLoadingManager;

implementation

constructor TLoadingManager.Create;
begin
  inherited Create;
  Color[0] := 1;
  Color[1] := 1;
  Color[2] := 1;
  Color[3] := 0;
  SetTexture(_HGE.Ini_GetString('LOADING','TEXTURE','loading.jpg'));
  Fnt := THGEFont.Create(_HGE.Ini_GetString('LOADING','FONT','loading.fnt'));
  TextPosX := SCR_CENTER_W-50;
  TextPosY := WND_HEIGHT-50;//WND_HEIGHT-round(Fnt.GetHeight)*2;
end;

procedure TLoadingManager.SetTexture(FileName : AnsiString);
begin
  Tex := _HGE.Texture_Load(FileName);
  Spr := THGESprite.Create(Tex,0,0,Tex.GetWidth,Tex.GetHeight);
end;

procedure TLoadingManager.Process(str : string = '');
begin
  if str <> '' then Loading.Text := str;
  if Loading.Color[3] < 1 then Loading.Color[3] := Loading.Color[3]+0.2;
  _HGE.Gfx_BeginScene();
  _HGE.Gfx_Clear(0);
  Spr.RenderStretch(0,0,WND_WIDTH,WND_HEIGHT);
  Fnt.SetColor($FFFF0000);
  Fnt.PrintF(TextPosX,TextPosY,HGETEXT_LEFT,Loading.Text,[]);
  _HGE.Gfx_EndScene;
  {begin_render(true);
  glDisable(GL_LIGHTING);
  glEnable(GL_BLEND);
  SetAlphaEffect(AE_ALPHA_BLEND);
    glColor4fv(@Loading.Color);
      glEnable(GL_TEXTURE_2D);
      TexMan.Bind(Texture);
      glBegin(GL_QUADS);
        glTexCoord2f(0,0);  glVertex2f(0,WND_Height);
        glTexCoord2f(1,0);  glVertex2f(WND_Width,WND_Height);
        glTexCoord2f(1,1);  glVertex2f(WND_Width,0);
        glTexCoord2f(0,1);  glVertex2f(0,0);
      glEnd;
      glDisable(GL_TEXTURE_2D);
    glDisable(GL_BLEND);
  FntMan.Text(Fnt,PChar(' : '+Text),TextPosX,TextPosY);
  //FntMan.TextBack(Fnt,Heart.version,WND_WIDTH,FntMan.Items[Fnt].HShift,$FFcccccc);
  FntMan.Text(Fnt,Text2,32,80,$FF0888FF);
  end_render;                             }
end;

procedure TLoadingManager.WaitPressAnyKey;
begin
   //if Input.WaitPressAnyKey then Game.State := gsGame;
end;

end.
