//=============================================================================
//           : Tower Defence
//   : e_Options.pas
//        :   
//            : Soulghai
//    : 07.11.2005
//       : /  
//=============================================================================

unit g_Options;

interface
uses
  windows,messages,HGE,
  g_types, g_utils;

type
  TOptions = class
    WinWidth,
    WinHeight,
    BitDepth,                                                                  //  
    Freq,                                                                      //   
    vSync : word;                                                              //  
    FullScreen : bool;                                                         //  
    ShowFps : bool;                                                            //    FPS
    Sound : boolean;                                                           // / 
    SoundVolume : byte;                                                        //  
    MusicVolume : byte;
    Language : string;
    procedure Load;
  end;

var
  Options : TOptions;

implementation

procedure TOptions.Load;
var
  hDCScreen : hdc;
begin
  FullScreen := boolean(_HGE.INI_GetInt('SCREEN','FULLSCREEN',0));
  if FullScreen then begin
    hDCScreen := GetDC(0);
    WinWidth := GetDeviceCaps(hDCScreen, HORZRES);
    WinHeight := GetDeviceCaps(hDCScreen, VERTRES);
    ReleaseDC(0, hDCScreen);
  end else begin
    WinWidth := _HGE.INI_GetInt('SCREEN','WND_WIDTH',800);
    WinHeight := _HGE.INI_GetInt('SCREEN','WND_HEIGHT',600);
  end;
  BitDepth := _HGE.INI_GetInt('SCREEN','BITDEPTH',32);
  Freq := _HGE.INI_GetInt('SCREEN','FREQ',60);
  vSync := _HGE.INI_GetInt('SCREEN','VSYNC',0);
  ShowFps := boolean(_HGE.INI_GetInt('SCREEN','SHOWFPS',1));
  Sound := boolean(_HGE.INI_GetInt('SOUND','SOUND',1));
  SoundVolume :=_HGE.INI_GetInt('SOUND','SOUND_VOLUME',100);
  MusicVolume :=_HGE.INI_GetInt('SOUND','MUSIC_VOLUME',50);
  WND_WIDTH  := WinWidth;
  WND_HEIGHT := WinHeight;
  SCR_CENTER_W := WND_WIDTH div 2;
  SCR_CENTER_H := WND_HEIGHT div 2;
  Language := _HGE.Ini_GetString('LANGUAGE','LANGUAGE','RUSSIAN');
  {if Lang = 'RUSSIAN' then Language := 0 else
  if Lang = 'ENGLISH' then Language := 1;  }
end;

end.
