unit g_TOP;

interface
uses
  windows,Classes,ShellApi,
  HGE,HGESprite,HGEFont,
  g_LevelManager,g_Types,g_cfg,g_Utils,g_Online_Top;

type
  TItems = class
    Name : string[9];
    Score : word;
    Color : Cardinal;
  end;

  TTOP = class
    Tex : ITexture;
    Spr : IHGESprite;
    Fnt : IHGEFont;
    Top : single;
    FilePath : string;
    List : array [0..1] of TList;
    ItemsCount : word;
    constructor Create;
    procedure LoadTOP;
    procedure SaveTOP;
    procedure Check(_Name : string;_Color:Cardinal;_Type : byte);
    procedure Render;
    procedure Update(const delta : single);
    procedure Clear;
    procedure Send_Top;
  end;

var
  TOP : TTOP;

implementation

procedure TTOP.Clear;
var i,j : byte;
begin
 { for j := 0 to 1 do
  for I := 0 to ItemsCount-1 do begin
    List[j].Add(TItems.Create);
  end; }
  for j := 0 to 1 do
  for I := 0 to ItemsCount-1 do begin
    TItems(List[j].Items[i]).Name := 'Unknown';
    TItems(List[j].Items[i]).Score := 0;
    TItems(List[j].Items[i]).Color := $ffffffff;
  end;
end;

procedure TTop.Send_Top;
var
  i : Integer;
  buf,url : String;
  cbuf : String;
  bbuf : String;
begin
  buf := '';
  //    
  for i := 0 to ItemsCount-1 do
  begin
    if buf <> '' then buf := buf + '|';
    buf := buf + 'name=' + TItems(List[0].Items[i]).name +
                 ':score=' + IntToStr(TItems(List[0].Items[i]).score) +
                 ':arena=' + 'accident' +
                 ':color=' + IntToStr(TItems(List[0].Items[i]).Color) + ':version=' + GAME_VERSION;
  end;
  //     
  cbuf := EncodeBase64(CryptXO7String(buf, 54)) + #3 + EncodeBase64(CryptXO7String(buf, 37));
  //          
  bbuf := EncodeBase64(cbuf);

  //       :
  // record.php?gameID=_&new=_bbuf
  //result := bbuf;

  //data := bbuf;
  //base64(data);
  url := 'http://www.ignisfire.tu2.ru/record.php?gameID=0&new=' + bbuf;
  ShellExecute(0, 'open', PChar(Url), nil, nil, SW_SHOW);
end;

constructor TTOP.Create;
begin
  inherited;
  List[0] := TList.Create;
  List[1] := TList.Create;
  Top := WND_HEIGHT;
  Tex := _HGE.Texture_Load(Cfg_ReadStr('data\cfg\top.cfg','TEXTURE_TOP','top.png'));
  Spr := THGESprite.Create(Tex,0,0,Tex.GetWidth,Tex.GetHeight);
  Spr.SetHotSpot(Tex.GetWidth/2,0);
  Fnt := THGEFont.Create(Cfg_ReadStr('data\cfg\top.cfg','FONT','default.fnt'));
  ItemsCount := 10;
  FilePath := 'data\top\top.txt';
  LoadTOP;
end;

procedure TTOP.LoadTOP;
var f : file of byte;
  i,j : byte;
begin
  AssignFile(f,FilePath);
  Reset(f);
  for j := 0 to 1 do
  for I := 0 to ItemsCount-1 do begin
    List[j].Add(TItems.Create);
    blockRead(f,TItems(List[j].Items[i]).Name,sizeof(TItems(List[j].Items[i]).Name));
    blockRead(f,TItems(List[j].Items[i]).Score,sizeof(TItems(List[j].Items[i]).Score));
    blockRead(f,TItems(List[j].Items[i]).Color,sizeof(TItems(List[j].Items[i]).Color));
    {TItems(List[j].Items[i]).Name := 'a';
    TItems(List[j].Items[i]).Score := 100;
    TItems(List[j].Items[i]).Color := $ffffff00;}
  end;
  CloseFile(f);
  //Send_Top;
end;

procedure TTOP.SaveTOP;
var f : file of byte;
  i,j : byte;
begin
  AssignFile(f,FilePath);
  Rewrite(f);
  for j := 0 to 1 do
  for I := 0 to ItemsCount-1 do begin
    blockWrite(f,TItems(List[j].Items[i]).Name,sizeof(TItems(List[j].Items[i]).Name));
    blockWrite(f,TItems(List[j].Items[i]).Score,sizeof(TItems(List[j].Items[i]).Score));
    blockWrite(f,TItems(List[j].Items[i]).Color,sizeof(TItems(List[j].Items[i]).Color));
  end;
  CloseFile(f);
end;

procedure TTOP.Check(_Name : string;_Color:Cardinal;_Type : byte);
var i,j : integer;
  temp : TItems;
  incr : integer;
begin
  Profile.Score := Profile.tScore;
  temp := TItems.Create;
  i := List[_Type].Add(TItems.Create);
  TItems(list[_Type].Items[i]).Name := _Name;
  TItems(list[_Type].Items[i]).Score := Profile.Score;
  TItems(list[_Type].Items[i]).Color := _Color;
  //***Sort***\\
 incr := (List[_Type].Count) div 2;
 while incr>0 do begin
   for i := incr to List[_Type].Count - 1 do begin
     j := i - incr;
     while(j>=0) do begin
       if TItems(list[_Type].Items[j]).Score<TItems(list[_Type].Items[j+incr]).Score then begin
         temp.Name := TItems(list[_Type].Items[j]).Name;
         temp.Score := TItems(list[_Type].Items[j]).Score;
         temp.Color := TItems(list[_Type].Items[j]).Color;
         TItems(list[_Type].Items[j]).Name := TItems(list[_Type].Items[j+incr]).Name;
         TItems(list[_Type].Items[j]).Score := TItems(list[_Type].Items[j+incr]).Score;
         TItems(list[_Type].Items[j]).Color := TItems(list[_Type].Items[j+incr]).Color;
         TItems(list[_Type].Items[j+incr]).Name := temp.Name;
         TItems(list[_Type].Items[j+incr]).Score := temp.Score;
         TItems(list[_Type].Items[j+incr]).Color := temp.Color;
         j := j-incr;
       end else j :=-1;
     end;
   end;
   incr := incr div 2;
 end;
 TItems(List[_Type].Items[List[_Type].Count-1]).free;
 List[_Type].Delete(List[_Type].Count-1);
end;

procedure TTOP.Update(const delta : single);
begin
  if Top > 140*WndAspect then Top := Top - 500*delta;
  if _HGE.Input_KeyDown(HGEK_C) then Clear;
  if _HGE.Input_KeyDown(HGEK_C) then SaveTOP;
end;

procedure TTOP.Render;
var
  I: Integer;
begin
  Spr.RenderEx(400*WndAspect,Top-15*WndAspect,0,2*WndAspect,1.7*WndAspect);
  Fnt.SetColor($ffffff33);
  Fnt.PrintF(400*WndAspect,Top,HGETEXT_CENTER,'TOP',[]);
  Fnt.SetColor($ffffff33);
  Fnt.PrintF(400*WndAspect,30*WndAspect+Top,HGETEXT_CENTER,'Adventure',[]);
  for I := 0 to ItemsCount - 1 do begin
    Fnt.SetColor(TItems(List[0].Items[i]).Color);
    Fnt.PrintF(400*WndAspect,(30*WndAspect+Top+i*(32)*WndAspect+32),HGETEXT_CENTER,
               TItems(List[0].Items[i]).Name+': %d',[TItems(List[0].Items[i]).Score]);
  end;
  //Fnt.SetColor($ff3333ff);
  //Fnt.PrintF(SCR_CENTER_W,Top-25,HGETEXT_CENTER,'elbomso',[]);
end;

end.
