//=============================================================================
//           : Tower Defence
//   : e_Utils.pas
//        :  
//            : Soulghai
//    : 07.11.2005
//       : 
//=============================================================================
//            :    -
//=============================================================================

unit g_Utils;

interface
uses
  windows;

  function FloatToStr( f : single ) : string;
  function IntToStr( Num : integer ) : string;
  function StrToInt(Value: string): integer;
  function FileExists(const FileName: string): bool;                           //    
  function Get_File_Path(Str : string) : string;                               //  
  function Get_File_Name(Str : string) : string;                               //   
  function UpperCase(const S: string): string;

  function SwapCardinal(card : Cardinal) : Cardinal;
  function SwapWord(card : Word) : Word;
  function SwapFloat(card : Single) : Single;

  function SplitString(s : string; var str : string) : string;

  function StrAlloc(Size: Cardinal): PChar;
  function StrCopy(Dest: PChar; const Source: PChar): PChar;

  procedure TimeToNormalTime(Time : Cardinal; var day,hour,minute,second : byte);
implementation

function FloatToStr( f : single ) : string;
begin
  Str( f:3:7, Result );
end;

function IntToStr( Num : integer ) : string;
begin
  Str( Num, Result );
end;

function StrToInt(Value: string): integer;
var
  i: integer;
begin
  Result:=0;
  if Value='' then exit;
  for i:=1 to Length(Value) do begin
    case Value[i] of
      '1': Result:=Result*10+1;
      '2': Result:=Result*10+2;
      '3': Result:=Result*10+3;
      '4': Result:=Result*10+4;
      '5': Result:=Result*10+5;
      '6': Result:=Result*10+6;
      '7': Result:=Result*10+7;
      '8': Result:=Result*10+8;
      '9': Result:=Result*10+9;
      '0': Result:=Result*10;
    end;
  end;
end;

function FileExists( const FileName : string ) : bool;
var
  hFile : THandle;
begin
  hFile := CreateFile(PChar(FileName), 0, 0, nil, OPEN_EXISTING, 0, 0);
  Result := hFile <> INVALID_HANDLE_VALUE;
  if Result then CloseHandle(hFile);
end;

function Get_File_Path(Str : string) : string;
var
  i : word;
  len : dword;
begin
  result := Str;
  if Str = '' then Exit;
  len := length(Str);
  for i := len downto 1 do
    if Str[i] = '\' then Break;
  delete(Result,i+1,length(Str)-i);
end;

function Get_File_Name(Str : string) : string;
var
  i : word;
  len : dword;
begin
  result := Str;
  if Str = '' then Exit;
  len := length(Str);
  for i := len downto 1 do
    if Str[i] = '\' then Break;
  Result := copy(Str,i+1,length(Str)-i);
end;

function UpperCase(const S: string): string;
var
  Ch: Char;
  L: integer;
  Source, Dest: PChar;
begin
  L := Length(S);
  SetLength(Result, L);
  Source := Pointer(S);
  Dest := Pointer(Result);
  while L <> 0 do
  begin
    Ch := Source^;
    if (Ch >= 'a') and (Ch <= 'z') then Dec(Ch, 32);
    Dest^ := Ch;
    Inc(Source);
    Inc(Dest);
    Dec(L);
  end;
end;

//============================================================================
//   Cardinal
//============================================================================
function SwapCardinal(card : Cardinal) : Cardinal;
var
  newcard : Cardinal;
  temp, temp2 : pchar;
begin
  newcard:= card;
  temp:= @card;
  temp2:= @newcard;

  temp2[0]:= temp[3];
  temp2[1]:= temp[2];
  temp2[2]:= temp[1];
  temp2[3]:= temp[0];

  Result:= newcard;
end;

//============================================================================
//   Word
//============================================================================
function SwapWord(card : Word) : Word;
var
  newcard : Word;
  temp, temp2 : pchar;
begin
  newcard:= card;
  temp:= @card;
  temp2:= @newcard;

  temp2[0]:= temp[1];
  temp2[1]:= temp[0];

  Result:= newcard;
end;

//============================================================================
//   Single
//============================================================================
function SwapFloat(card : Single) : Single;
var
  newcard : Single;
  temp, temp2 : pchar;
begin
  newcard:= card;
  temp:= @card;
  temp2:= @newcard;

  temp2[0]:= temp[3];
  temp2[1]:= temp[2];
  temp2[2]:= temp[1];
  temp2[3]:= temp[0];

  Result:= newcard;
end;

function SplitString(s : string; var str : string) : string;
var
  res : string;
  cnt : integer;
  sl : integer;
begin
  cnt := Pos(s, str);
  sl := Length(s);
  if cnt > 0 then
  begin
    if sl > 1 then
      res := '';
    res := copy(str, 1, cnt-sl);
    str := copy(str, cnt + sl, Length(str)-(cnt-sl-1));
  end
  else
  begin
    res := str;
    str := '';
  end;
  Result := res;
end;

function StrAlloc(Size: Cardinal): PChar;
begin
  Inc(Size, SizeOf(Cardinal));
  GetMem(Result, Size);
  Cardinal(Pointer(Result)^) := Size;
  Inc(Result, SizeOf(Cardinal));
end;

function StrCopy(Dest: PChar; const Source: PChar): PChar;
asm
  sub   edx, eax
  test  eax, 1
  push  eax
  jz    @loop
  movzx ecx, byte ptr[eax+edx]
  mov   [eax], cl
  test  ecx, ecx
  jz    @ret
  inc   eax
@loop:
  movzx ecx, byte ptr[eax+edx]
  test  ecx, ecx
  jz    @move0
  movzx ecx, word ptr[eax+edx]
  mov   [eax], cx
  add   eax, 2
  cmp   ecx, 255
  ja    @loop
@ret:
  pop   eax
  ret
@move0:
  mov   [eax], cl
  pop   eax
end;

procedure TimeToNormalTime(Time : Cardinal; var day,hour,minute,second : byte);
begin
  day := Time div 24*3600;
  hour := Time div 3600;
  minute := Time div 60;
  second := Time mod 60;
end;

end.
 