unit g_bonus;

interface
uses
  Classes,
  HGE,HGESprite,HGEFont,HGEParticle,
  g_Types,g_Options,g_cfg,g_utils,g_math,g_map;

const
  BONUS_COUNT = 9;

type
  TBonusState = (bsDead,bsLive,bsWork);
  TBonusType = (btRandom,btChuma,btSpeed,btInvisible,btMagnit,btChuma_Start,
                btRepair,btMoney,btMoney_x2{,btBoom});
  PBonus = ^TBonus;
  TBonus = class
    X,Y : single;
    _Type : TBonusType;
    _State : TBonusState;
    Angle,Size : single;
    ShowFreq : single;                                                         //  
    ShowTime : single;                                                         //   ()
    EffectDelay : single;                                                      //    
    Text : string;
    Particle : IHGEParticleSystem;
    //   \\
    Money_add : integer;
    Color : cardinal;
    constructor Create;
    procedure Dead;
    procedure Effect(const id : word);
    procedure noEffect;
    procedure Update;
  end;

  TBonusManager=class
  public
    List : TList;
    Tex,TexEffect : array [0..BONUS_COUNT-1] of ITexture;
    Spr,SprEffect : array [0..BONUS_COUNT-1] of IHGESprite;
    sndGive : IEffect;
    TexBonus,TexParticle : ITexture;
    SprBonus : IHGESprite;
    Time_Random,Time_Speed,Time_Invisible,
    Time_Magnit,Time_Chuma_Start,Time_Chuma,
    Time_Repair,Time_Money,Time_Money_x2,btBoom : word;
    constructor Create;
    destructor Destroy;
    procedure Init;
    procedure Render;
    procedure RenderGUI;
    function Find : integer;
    function Add(__type : TBonusType) : integer;
    procedure Update(const delta : single);
    procedure CollisionCalc;
  end;

var
  BonusManager : TBonusManager;

implementation
uses
  g_gui;

constructor TBonus.Create;
begin
  inherited;
  Money_add:=Cfg_ReadInt('data\cfg\bonus.cfg','BONUS_MONEY_ADD',100);
end;

procedure TBonus.Dead;
begin
  _State := bsDead;
  ParSysDelete(Particle);
end;

procedure TBonus.Effect(const id : word);
begin
  {case _Type of
    btSpeed: begin
      TPlayer(PlayerManager.List.Items[PlayerID]).Acceleration := TPlayer(PlayerManager.List.Items[PlayerID]).Acceleration*1.5;
        ToggleParSys(TPlayer(PlayerManager.List.Items[PlayerID]).Particle,
                   'data\particles\particle_speed.psi',TPlayer(PlayerManager.List.Items[PlayerID]).TexParticle,
                   0,0,32,16,16,BLEND_ALPHAADD);
    end;
    btInvisible: TPlayer(PlayerManager.List.Items[PlayerID]).Invisible := true;
    btChuma_Start : begin
      PlayerID2 := PlayerID;
      TPlayer(PlayerManager.List.Items[PlayerID]).MyBonus[ord(btChuma_Start)] := self;
      ToggleParSys(TPlayer(PlayerManager.List.Items[PlayerID]).bonusParticle,
                   'data\particles\Bonus_Chuma_Effect.psi',TPlayer(PlayerManager.List.Items[PlayerID]).TexParticle,
                   0,0,32,16,16,BLEND_ALPHAADD);
    end;
    btRepair : begin
      if TPlayer(PlayerManager.List.Items[PlayerID]).Life<TPlayer(PlayerManager.List.Items[PlayerID]).MaxLife then
        inc(TPlayer(PlayerManager.List.Items[PlayerID]).Life);
      Dead;
      exit;
    end;
    btMoney : begin
      inc(TPlayer(PlayerManager.List.Items[PlayerID]).Score,Money_add);
      Dead;
      exit;
    end;
    btMoney_x2 : begin
      TPlayer(PlayerManager.List.Items[PlayerID]).BonusMul := 2;
    end;
   { btBoom : begin
      TPlayer(PlayerManager.List.Items[PlayerID]).MyBonus[ord(btBoom)] := self;
    end; }
  //end;
end;

procedure TBonus.noEffect;
var i : word;
begin
  {case _Type of
    btSpeed: begin
      TPlayer(PlayerManager.List.Items[PlayerID]).Acceleration := TPlayer(PlayerManager.List.Items[PlayerID]).Acceleration/1.5;
       ToggleParSys(TPlayer(PlayerManager.List.Items[PlayerID]).Particle,'data\particles\particle_smoke.psi',
                    TPlayer(PlayerManager.List.Items[PlayerID]).TexParticle,0,0,32,16,16,BLEND_ALPHABLEND or BLEND_COLORMUL);
    end;
    btInvisible: TPlayer(PlayerManager.List.Items[PlayerID]).Invisible := false;
    btMagnit: begin
      for I := 0 to MuchachoManager.List.Count - 1 do
        with TMuchacho(MuchachoManager.List.Items[i]) do
          if _State=msLive then
          if Color=TPlayer(PlayerManager.List.Items[PlayerID]).Color then begin
            ThinkTime := ThinkDelay;
          end;
    end;
    btChuma_Start : begin
      _Type := btChuma;
      ShowTime := 0;
      TPlayer(PlayerManager.List.Items[PlayerID]).MyBonus[ord(btChuma_Start)] := nil;
      ParSysDelete(TPlayer(PlayerManager.List.Items[PlayerID]).bonusParticle);
      PlayerID := PlayerID2;
      ToggleParSys(TPlayer(PlayerManager.List.Items[PlayerID]).bonusParticle,
                   'data\particles\Bonus_Chuma_Effect.psi',TPlayer(PlayerManager.List.Items[PlayerID]).TexParticle,
                   0,0,32,16,16,BLEND_ALPHAADD,$ffff0000);
      exit;
    end;
    btChuma : begin
      for I := 0 to MuchachoManager.List.Count - 1 do
        with TMuchacho(MuchachoManager.List.Items[i]) do
          if _State=msLive then
          if Color<>TPlayer(PlayerManager.List.Items[PlayerID]).Color then begin
            ThinkTime := ThinkDelay;
          end;
      ParSysDelete(TPlayer(PlayerManager.List.Items[PlayerID]).bonusParticle);
    end;
    btMoney_x2 : TPlayer(PlayerManager.List.Items[PlayerID]).BonusMul := 1;
    //btBoom : TPlayer(PlayerManager.List.Items[PlayerID]).MyBonus[ord(btChuma_Start)] := nil;
  end;
  Dead; }
end;

procedure TBonus.Update;
var i : word;
begin
 { case _Type of
    btSpeed: ;
    btInvisible: ;
    btMagnit: begin
      for I := 0 to MuchachoManager.List.Count - 1 do
        with TMuchacho(MuchachoManager.List.Items[i]) do
          if _State=msLive then
          if Color=TPlayer(PlayerManager.List.Items[PlayerID]).Color then begin
            TargetX := TPlayer(PlayerManager.List.Items[PlayerID]).X;
            TargetY := TPlayer(PlayerManager.List.Items[PlayerID]).Y;
            ThinkTime := 0;
          end;
    end;
    btChuma : begin
      for I := 0 to MuchachoManager.List.Count - 1 do
        with TMuchacho(MuchachoManager.List.Items[i]) do
          if _State=msLive then
          if Color<>TPlayer(PlayerManager.List.Items[PlayerID2]).Color then begin
            TargetX := TPlayer(PlayerManager.List.Items[PlayerID2]).X;
            TargetY := TPlayer(PlayerManager.List.Items[PlayerID2]).Y;
            ThinkTime := 0;
          end;
    end;
  end;  }
end;

constructor TBonusManager.Create;
var i : integer;
begin
  inherited;
  List := TList.Create;
  sndGive := _HGE.Effect_Load(Cfg_ReadStr('data\cfg\bonus.cfg','SOUND_GIVE','bonus_give.ogg'));
  for I := 0 to BONUS_COUNT-1 do begin
    Tex[i] := _HGE.Texture_Load(Cfg_ReadStr('data\cfg\bonus.cfg','TEXTURE_'+inttostr(i+1),'bonus.png'));
    Spr[i] := THGESprite.Create(Tex[i],0,0,Tex[i].GetWidth,Tex[i].GetHeight);
    Spr[i].SetHotSpot(Tex[i].GetWidth / 2,Tex[i].GetHeight / 2);
    Spr[i].SetColor($ffffffff);

    TexEffect[i] := _HGE.Texture_Load(Cfg_ReadStr('data\cfg\bonus.cfg','TEXTURE_EFFECT_'+inttostr(i+1),'bonus.png'));
    SprEffect[i] := THGESprite.Create(TexEffect[i],0,0,TexEffect[i].GetWidth,TexEffect[i].GetHeight);
    SprEffect[i].SetHotSpot(TexEffect[i].GetWidth / 2,TexEffect[i].GetHeight / 2);
    SprEffect[i].SetColor($aaffffff);
  end;
  TexParticle := _HGE.Texture_Load(Cfg_ReadStr('data\cfg\player.cfg','TEXTURE_PARTICLE','particles.png'));
  TexBonus := _HGE.Texture_Load(Cfg_ReadStr('data\cfg\bonus.cfg','TEXTURE_BONUS','bonus.png'));
  SprBonus := THGESprite.Create(TexBonus,0,0,TexBonus.GetWidth,TexBonus.GetHeight);
  SprBonus.SetHotSpot(TexBonus.GetWidth / 2,TexBonus.GetHeight / 2);
  SprBonus.SetColor($ffffffff);
  Time_Random:=Cfg_ReadInt('data\cfg\bonus.cfg','TIME_RANDOM',15);
  Time_Speed:=Cfg_ReadInt('data\cfg\bonus.cfg','TIME_SPEED',15);
  Time_Invisible:=Cfg_ReadInt('data\cfg\bonus.cfg','TIME_INVISIBLE',35);
  Time_Magnit:=Cfg_ReadInt('data\cfg\bonus.cfg','TIME_MAGNIT',60);
  Time_Chuma_Start:=Cfg_ReadInt('data\cfg\bonus.cfg','TIME_CHUMA',120);
  Time_Chuma:=high(word);
  Time_Repair:=Cfg_ReadInt('data\cfg\bonus.cfg','TIME_REPAIR',90);
  Time_Money:=Cfg_ReadInt('data\cfg\bonus.cfg','TIME_MONEY',90);
  Time_Money_x2:=Cfg_ReadInt('data\cfg\bonus.cfg','TIME_MONEY_X2',90);
end;

procedure TBonusManager.Init;
var i : integer;
begin
  I := List.Count-1;
  while i > 0 do begin
    TBonus(List.Items[i]).free;
    dec(i);
  end;
  List.Clear;
  for i := 0 to BONUS_COUNT - 1 do     
    Add(TBonusType(i));
end;

function TBonusManager.Find : integer;
var
  i : word;
begin
  result := -1;
  i:=BONUS_COUNT;
  while i<List.Count do begin
    if TBonus(List.Items[i])._State = bsDead then begin
      result := i;
      break;
    end;
    inc(i);
  end;
end;

function TBonusManager.Add(__type : TBonusType) : integer;
begin
  // Create Players \\
  result := Find;
  if result =-1 then begin
    result := List.Add(TBonus.Create);
  end;
  with TBonus(List.Items[result]) do begin
    _Type := __Type;
    case _Type of
      btRandom: begin
        ShowFreq := Time_Random;
      end;
      btSpeed: begin
        ShowFreq := Time_Speed;
      end;
      btInvisible: begin
        ShowFreq := Time_Invisible;
      end;
      btMagnit: begin
        ShowFreq := Time_Magnit;
      end;
      btChuma_Start : begin
        ShowFreq := Time_Chuma_Start;
      end;
      btChuma : begin
        ShowFreq := Time_Chuma;
      end;
      btRepair : begin
        ShowFreq := Time_Repair;
      end;
      btMoney : begin
        ShowFreq := Time_Money;
      end;
      btMoney_x2 : begin
        ShowFreq := Time_Money_x2;
      end;
    end;

    if result >= BONUS_COUNT then
    ToggleParSys(Particle,'data\particles\particle_bonus.psi',TexParticle,0,32,32,round(X),round(Y),
                 BLEND_ALPHAADD,$ff00ff00,$ffff8800);
    Angle := 0;
    ShowTime := 0;
    EffectDelay := 10;
    Color := $00ffffff;
    _State := bsLive;
  end;
end;

procedure TBonusManager.Render;
var i : byte;
begin
  i := BONUS_COUNT;
  while i < List.Count do begin
    with TBonus(List.Items[i]) do
      if _State=bsLive then begin
       // 
        SprBonus.SetColor(Color);
        SprBonus.RenderEx(X,Y,-deg2rad*Angle,Size);
        Spr[ord(TBonusType(_Type))].SetColor(Color);
        Spr[ord(TBonusType(_Type))].RenderEx(X,Y,0,1);
      end else if _State=bsWork then begin
        //SprEffect[ord(TBonusType(_Type))].RenderEx(TPlayer(PlayerManager.List.Items[PlayerID]).X,
        //                                     TPlayer(PlayerManager.List.Items[PlayerID]).Y,0,0.75);
      end;
    inc(i);
  end;
end;

procedure TBonusManager.RenderGUI;
var
  i,j,j1,j2 : byte;
  X : word;
begin
  {j1 := 0;
  j2 := 0;
  i := BONUS_COUNT;
  while i < List.Count do begin
    if TBonus(List.Items[i])._State=bsWork then
    with TBonus(List.Items[i]) do begin
    if (PlayerID=PlayerManager.Players[0]) then begin
      X := 24;
      j := j1;
      inc(j1);
    end  else
    if (PlayerID=PlayerManager.Players[1]) then begin
      X := SCR_CENTER_W+24;
      j := j2;
      inc(j2);
    end;
    if (PlayerID=PlayerManager.Players[0]) or (PlayerID=PlayerManager.Players[1]) then begin
        SprBonus.SetColor($ffffffff);
        SprBonus.RenderEx(X,WND_HEIGHT-32-j*48,0,0.75);
        Spr[ord(TBonusType(_Type))].SetColor($ffffffff);
        Spr[ord(TBonusType(_Type))].RenderEx(X,WND_HEIGHT-32-j*48,0,0.75);
        GUI.Fnt.SetColor(TPlayer(PlayerManager.List.Items[PlayerManager.Players[0]]).Color);
        GUI.Fnt.PrintF(X+28,WND_HEIGHT-48-j*48,HGETEXT_LEFT,' : %.0f',[EffectDelay-ShowTime]);
      end;
    end;
    inc(i);
  end;   }
end;

procedure TBonusManager.Update(const delta : single);
var i : byte;
begin
  i := BONUS_COUNT;
  while i < List.Count do begin
    with TBonus(List.Items[i]) do
    case _State of
      bsLive : begin
        if Angle < 360 then Angle := Angle + 2 else Angle := 0;
        if Particle <> nil then
          particle.MoveTo(X-32*cos(deg2rad*(Angle*2)),Y-32*sin(deg2rad*(Angle*2)));
      end;
      bsWork : begin
        ShowTime := ShowTime + delta;
        if ShowTime > EffectDelay then noEffect else Update;
      end;
    end;
    inc(i);
  end;

  CollisionCalc;

  i := 0;
  while i < BONUS_COUNT do begin
    with TBonus(List.Items[i]) do begin
      ShowTime := ShowTime + delta;
      if ShowTime > ShowFreq then begin
        Add(TBonusType(i));
        ShowTime := 0;
      end;
    end;
    inc(i);
  end;
end;

destructor  TBonusManager.destroy;
var i : byte;
begin
  sndGive := nil;
  for I := List.Count-1 downto 0 do begin
    TBonus(List.Items[i]).free;
  end;
  List.Clear;
end;

procedure TBonusManager.CollisionCalc;
var
  i,j : word;
begin
 {i := BONUS_COUNT;
 while i < List.Count do begin
    j := 0;
    if TBonus(List.Items[i])._State=bsLive then
    while j < PlayerManager.List.Count do begin
      if 32 > Distance2D(TBonus(List.Items[i]).X,TBonus(List.Items[i]).Y,
                         TPlayer(PlayerManager.List.Items[j]).X,TPlayer(PlayerManager.List.Items[j]).Y) then
      begin
        if TBonus(List.Items[i])._Type=btRandom then TBonus(List.Items[i])._Type:= TBonusType(2+Random(BONUS_COUNT-2));
        if not FindEffect(i,j) then TBonus(List.Items[i]).Effect(j);
        sndGive.PlayEx(Options.SoundVolume);
        Respown.Del(i);
        exit;
      end;
      inc(j);
    end;
   inc(i);
  end; }
end;

end.
