unit g_boss_BigHead;

interface
uses
  Windows,Classes,
  HGE,HGESprite,HGEParticle,g_Options,
  g_Types,g_cfg,g_math;

type
  TBullet= class
    X,Y : Single;
    active : boolean;
    angle : single;
    Color : cardinal;
  end;

  THand = class
    X,Y,tY,Radius,Length : single;
    Life,MaxLife : integer;
    Particle : IHGEParticleSystem;
    active : boolean;
    procedure Dead;
    procedure Damage(Value : word;_Snd : IEffect);
  end;

  TBoss_BigHeadManager = class
   public
     X,Y : Single;
     StopX,StopY : Single;

     Life : integer;
     ReloadTimeEYE,ReloadTimeHand,ReloadTimeADDMonster : single;
     Angle : single;
     Tex,TexHand : ITexture;
     Spr,SprHand : IHGESprite;
     Speed : single;
     MaxLife : integer;
     Radius : single;

     List : TList;
     BulletSpeed : single;
     BulletTex : ITexture;
     BulletSpr : IHGESprite;
     ReloadDelay : single;
     RotateSpeed : single;
     BulletDamage : word;
     BulletRadius : single;
     Hand : array [0..1] of THand;
     sndVoice,SndDead : IEffect;
   public
    constructor Create;
    destructor Destroy;
    procedure Init;
    function AddBullet(_X,_Y : single) : integer;
    procedure AddHandBullet(_X,_Y : single);
    procedure AddEYEBullet(_X,_Y : single);
    procedure Render();
    procedure Update(const delta : single);
    procedure Damage(Value : word);
    procedure Dead;
    procedure Go(_X,_Y : single);
  end;

var
  Boss_BigHead : TBoss_BigHeadManager;
  BosBigHead_Particle : IHGEParticleSystem;
  BosBigHead_TexParticle : ITexture;

implementation
uses
  g_player,g_monster_nlo,g_monster_bee;

procedure THand.Dead;
var i : byte;
begin
  //if TBoss_BigHead(List.Items[id]).Particle <> nil then
  //  TBoss_BigHead(List.Items[id]).Particle.FireAt(round(TBoss_BigHead(List.Items[id]).X),round(TBoss_BigHead(List.Items[id]).Y));
  Particle.Stop(true);
  for I := 0 to 9  do
    Monsters_BEE.AddMonster(X+random(round(radius*2))-random(round(radius*2)),Y+random(round(radius*2))-random(round(radius*2)));
  Life := -1;
end;

procedure THand.Damage(Value : word;_Snd : IEffect);
begin
  dec(Life,Value);
  if Life<=0 then begin
    if active then begin
      Dead;
      active := false;
      _Snd.PlayEx(Options.SoundVolume);
      Profile.tScore := Profile.tScore + 100;
    end;
  end else
  if Life < maxLife / 2 then
  if Particle = nil then
    ToggleParSys(Particle,'data\particles\particle_fire.psi',BosBigHead_TexParticle,0,0,32,
                 round(X),round(Y),
                 BLEND_ALPHABLEND or BLEND_COLORMUL or BLEND_ALPHAADD);
end;

function TBoss_BigHeadManager.AddBullet(_X,_Y : single) : integer;
var
  i : word;
begin
  Result := -1;
  i:=0;
  while i<List.Count do begin
    with TBullet(List.Items[i]) do begin
      if not active then begin
        Result := i;
        break;
      end;
    end;
    inc(i);
  end;

  if Result = -1 then Result := List.Add(TBullet.Create);
  with TBullet(List.Items[Result]) do begin
    X := _X;
    Y := _Y;
    Angle := 90;
    active := true;
  end;
end;

procedure TBoss_BigHeadManager.AddHandBullet(_X,_Y : single);
var ID : integer;
begin
  ID := AddBullet(_X,_Y);
  TBullet(List.Items[ID]).Color := $ffff0000;
  ID := AddBullet(_X+15*WndAspect,_Y);
  TBullet(List.Items[ID]).Color := $ffff0000;
  ID := AddBullet(_X-15*WndAspect,_Y);
  TBullet(List.Items[ID]).Color := $ffff0000;
end;

procedure TBoss_BigHeadManager.AddEYEBullet(_X,_Y : single);
var ID : integer;
begin
  ID := AddBullet(_X,_Y);
  TBullet(List.Items[ID]).angle := GetAngle(_X,_Y,Player.X,Player.Y);
  TBullet(List.Items[ID]).Color := $ffffff00;
end;

constructor TBoss_BigHeadManager.Create;
var
  FileName : string;
begin
  inherited;
  FileName := 'data\cfg\Boss_BigHead.cfg';
  Tex := _HGE.Texture_Load(Cfg_ReadStr(FileName,'TEXTURE',''));
  Spr := THGESprite.Create(Tex,0,0,Tex.GetWidth,Tex.GetHeight);
  Spr.SetHotSpot(Tex.GetWidth / 2,Tex.GetHeight / 2);
  Spr.SetColor($ffffffff);
  TexHand := _HGE.Texture_Load(Cfg_ReadStr(FileName,'TEXTURE_HAND',''));
  SprHand := THGESprite.Create(TexHand,0,0,TexHand.GetWidth,TexHand.GetHeight);
  SprHand.SetHotSpot(TexHand.GetWidth / 2,TexHand.GetHeight / 2);
  SprHand.SetColor($ffffffff);
  BosBigHead_TexParticle := _HGE.Texture_Load(Cfg_ReadStr(FileName,'TEXTURE_PARTICLE','particles.png'));
  sndVoice := _HGE.Effect_Load(Cfg_ReadStr(FileName,'SOUND_VOICE','boss_hand_voice.wav'));
  sndDead := _HGE.Effect_Load(Cfg_ReadStr(FileName,'SOUND_DEAD','boss_hand_dead.wav'));
  Speed := Cfg_ReadInt(FileName,'SPEED',6)*WndAspect/10;
  MaxLife := Cfg_ReadInt(FileName,'LIFE',6);
  Radius := 64*WndAspect;
  List := TList.Create;
  BulletTex := _HGE.Texture_Load(Cfg_ReadStr(FileName,'BULLET_TEXTURE',''));
  BulletSpr := THGESprite.Create(BulletTex,0,0,BulletTex.GetWidth,BulletTex.GetHeight);
  BulletSpr.SetHotSpot(BulletTex.GetWidth / 2,BulletTex.GetHeight / 2);
  BulletSpr.SetColor($ffff8800);
  BulletSpeed := Cfg_ReadInt(FileName,'BULLET_SPEED',6)*WndAspect;
  ReloadDelay := Cfg_ReadInt(FileName,'RELOAD_DELAY',6)/100;
  RotateSpeed := Cfg_ReadInt(FileName,'ROTATE_SPEED',6)/10;
  BulletDamage := Cfg_ReadInt(FileName,'BULLET_DAMAGE',6);
  BulletRadius := 16*WndAspect;
  Angle := 90;
  Life := -1;
  StopY := WND_HEIGHT div 4;
  Hand[0] := THand.Create;
  Hand[1] := THand.Create;
  Hand[0].tY := StopY;
  Hand[1].tY := StopY;
  Hand[0].Length := 100*WndAspect;
  Hand[1].Length := 100*WndAspect;
  Hand[0].Radius := 32*WndAspect;
  Hand[1].Radius := 32*WndAspect;
  Hand[0].MaxLife := MaxLife div 2;
  Hand[1].MaxLife := MaxLife div 2;
end;

destructor TBoss_BigHeadManager.Destroy;
begin
  sndVoice := nil;
  sndDead := nil;
  inherited;
end;

procedure TBoss_BigHeadManager.Init;
begin
  list.Clear;
  ReloadTimeEYE := 0;
  ReloadTimeHand := 0;
  Hand[0].X := SCR_CENTER_W-Hand[0].Length;
  Hand[1].X := SCR_CENTER_W+Hand[1].Length;
  Hand[0].Life := Hand[0].MaxLife;
  Hand[1].Life := Hand[1].MaxLife;
  Hand[0].active := true;
  Hand[1].active := true;
  Life := -1;
end;

procedure TBoss_BigHeadManager.Go(_X,_Y : single);
begin
  Life := MaxLife;
  X := _X;
  Y := _Y;
  Speed := abs(Speed);
  sndVoice.PlayEx(Options.SoundVolume);
end;

procedure TBoss_BigHeadManager.Damage(Value : word);
begin
  dec(Life,Value);
  if Life < maxLife / 2 then
  if BosBigHead_Particle = nil then
    ToggleParSys(BosBigHead_Particle,'data\particles\particle_fire.psi',BosBigHead_TexParticle,0,0,32,
                 round(X),round(Y),
                 BLEND_ALPHABLEND or BLEND_COLORMUL or BLEND_ALPHAADD);
  if Life<=0 then begin
    Dead;
    Profile.tScore := Profile.tScore + 500;
  end;
end;

procedure TBoss_BigHeadManager.Dead;
var
  I: Integer;
begin
  for I := 0 to 10 - 1 do
    ToggleParSys(BosBigHead_Particle,'data\particles\particle_gun_rocket.psi',BosBigHead_TexParticle,64,0,32,
                 round(X+random(round(radius))-random(round(radius))),round(Y+random(round(radius))-random(round(radius))),
                 BLEND_ALPHABLEND or BLEND_COLORMUL or BLEND_ALPHAADD,$ff55ccff,$ffffffff);
  //if TBoss_BigHead(List.Items[id]).Particle <> nil then
  //  TBoss_BigHead(List.Items[id]).Particle.FireAt(round(TBoss_BigHead(List.Items[id]).X),round(TBoss_BigHead(List.Items[id]).Y));
  Life := -1;
  sndDead.PlayEx(Options.SoundVolume);
  inc(Player.DeadCount);
  LevelManager.GameOver(true);
end;

procedure TBoss_BigHeadManager.Update(const delta : single);
var j : word;
begin
    if Life > 0 then begin
      if Y < StopY then begin
        Y := Y + Speed;
        Hand[0].Y := Y;
        Hand[1].Y := Y;
      end else begin
        if Speed>0 then
        if X+Hand[0].Length+Hand[0].Radius < WND_WIDTH then X := X + Speed else Speed := -Speed else
        if X-Hand[1].Length-Hand[1].Radius > 0 then X := X + Speed else Speed := -Speed;
        Hand[0].X := X - Hand[0].Length;
        if Hand[0].Y < Hand[0].tY then Hand[0].Y := Hand[0].Y + 1*WndAspect;
        Hand[1].X := X + Hand[1].Length;
        if Hand[1].Y < Hand[1].tY then Hand[1].Y := Hand[1].Y + 1*WndAspect;
      end;

      angle := GetAngle(X,Y,Player.X,Player.Y);
      if Distance2D(X,Y,Player.X,Player.Y) < Radius+Player.Radius then begin
        Player.Damage(20);
      end;
      // Add bullet
      ReloadTimeHand := ReloadTimeHand + delta;
      if ReloadTimeHand > ReloadDelay/2 then begin
        if Hand[0].Life>0 then
        AddHandBullet(X-Hand[0].Length,Y);
        Hand[0].Y := Y-10*WndAspect;
        if Hand[1].Life>0 then
        AddHandBullet(X+Hand[1].Length,Y);
        Hand[1].Y := Y-10*WndAspect;
        ReloadTimeHand := 0;
      end;
      ReloadTimeEYE := ReloadTimeEYE + delta;
      if ReloadTimeEYE > ReloadDelay then begin
        AddEYEBullet(X-20*WndAspect,Y);
        AddEYEBullet(X+20*WndAspect,Y);
        ReloadTimeEYE := 0;
      end;
      ReloadTimeADDMonster := ReloadTimeADDMonster + delta;
      if ReloadTimeADDMonster > ReloadDelay*2 then begin
          Monsters_NLO.AddMonster(X+radius*cos(deg2rad*Angle),Y+Radius*sin(deg2rad*Angle));
        ReloadTimeADDMonster := 0;
      end;
      if Hand[0].particle<>nil then Hand[0].particle.MoveTo(Hand[0].X,Hand[0].Y-Hand[0].Radius);
      if Hand[1].particle<>nil then Hand[1].particle.MoveTo(Hand[1].X,Hand[1].Y-Hand[1].Radius);
      if BosBigHead_Particle<>nil then BosBigHead_Particle.MoveTo(X,Y-Radius);
    end;

      //move
      j := 0;
      while j< List.Count do begin
        with TBullet(List.Items[j]) do
        if active then begin
          if (Y > WND_HEIGHT-10)or(Y < 10)
          or (X > WND_WIDTH-10)or(X < 10) then
            active := false else begin
            X := X + BulletSpeed*cos(deg2rad*Angle);
            Y := Y + BulletSpeed*sin(deg2rad*Angle);
            if Distance2D(Player.X,Player.Y,X,Y)< Player.Radius then begin
              active := false;
              Player.Damage(BulletDamage);
            end;
          end;
        end;
        inc(j);
      end;
end;

procedure TBoss_BigHeadManager.Render();
var j : word;
begin
  if Life > 0 then begin
    Spr.RenderEx(X,Y,deg2rad*Angle,1*WndAspect);
    if Hand[0].Life>0 then
     SprHand.RenderEx(Hand[0].X,Hand[0].Y,0,1*WndAspect);
    if Hand[1].Life>0 then
     SprHand.RenderEx(Hand[1].X,Hand[1].Y,0,1*WndAspect);
  end;

  j := 0;
  while j < List.Count do begin
  with TBullet(List.Items[j]) do
    if active then begin
      BulletSpr.SetColor(Color);
      BulletSpr.RenderEx(X,Y,deg2rad*180,1*WndAspect);
    end;
    inc(j)
  end;
end;

end.
