unit g_camera;

interface
uses
  HGE,
  g_types,g_math;

type
  TCameraType = (ctFree,ctPlayer);
  TCamera = class
    X,Y,tX,tY : single;
    ViewID : integer;
    Zoom,tZoom : single;
    _Type : TCameraType;
    Time,sTime : single;
    SpeedX,SpeedY,SpeedZoom : single;
    ParamX,ParamY,ParamTime,ParamDelay : single;
    constructor Create;
    procedure Reset;
    procedure Shaking(_X,_Y,_Delay : single);
    procedure Update(_X,_Y : single);
    procedure MoveTo(_X,_Y,_Z,_Time : single);
    procedure View;
    procedure ViewPlayer1(_X,_Y : single);
    procedure ViewPlayer2(_X,_Y : single);
  end;

var
  Camera : TCamera;

implementation

constructor TCamera.Create;
begin
  inherited;
  X := 0;
  Y := 0;
  Zoom := 1;
  _Type := ctPlayer;
  ParamX := 0;
  ParamY := 0;
end;

procedure TCamera.Reset;
begin
  _hge.Gfx_SetTransform;
end;

procedure TCamera.Shaking(_X,_Y,_Delay : single);
begin
  ParamX := _X;
  ParamY := _Y;
  ParamDelay := _Delay;
  ParamTime := 0;
end;

procedure TCamera.Update(_X,_Y : single);
begin
  case _type of
    ctFree: begin
      sTime := sTime + GAME_GLOBAL_SPEED;
      //if sTime>Time then _Type := ctPlayer;
      Aspire(X,tX,SpeedX);
      Aspire(Y,tY,SpeedY);
      Aspire(Zoom,tZoom,SpeedZoom);
      _hge.Gfx_SetTransform(X, Y, SCR_CENTER_W-X, SCR_CENTER_H-Y, 0, Zoom, Zoom);
    end;
    ctPlayer: begin
      X := _X;
      Y := _Y;
      ParamTime := ParamTime+GAME_GLOBAL_SPEED;
      if ParamTime>ParamDelay then begin
        ParamX:=-ParamX;
        ParamY:=-ParamY;
        Aspire(ParamX,0,abs(ParamX/2));
        Aspire(ParamY,0,abs(ParamY/2));
        ParamTime := 0;
      end;
    end;
  end;
end;

procedure TCamera.MoveTo(_X,_Y,_Z,_Time : single);
begin
  tX := _X;
  tY := _Y;
  tZoom := _Z;
  sTime := 0;
  Time := _Time;
  SpeedX := abs(X-_X)/_Time*GAME_GLOBAL_SPEED;
  SpeedY := abs(Y-_Y)/_Time*GAME_GLOBAL_SPEED;
  SpeedZoom := abs(Zoom-_Z)/_Time*GAME_GLOBAL_SPEED;
end;

procedure TCamera.View;
begin
   _hge.Gfx_SetTransform(X+ParamX, Y+ParamY, SCR_CENTER_W-X-ParamX, SCR_CENTER_H-Y-ParamY, 0, Zoom, Zoom);
end;

procedure TCamera.ViewPlayer1(_X,_Y : single);
begin
   _hge.Gfx_SetTransform(_X+ParamX,_Y+ParamY,SCR_CENTER_W*0.5-_X-ParamX, SCR_CENTER_H-_Y-ParamY, 0, Zoom, Zoom);
end;
procedure TCamera.ViewPlayer2(_X,_Y : single);
begin
   _hge.Gfx_SetTransform(_X+ParamX,_Y+ParamY,SCR_CENTER_W*1.5-_X-ParamX, SCR_CENTER_H-_Y-ParamY, 0, Zoom, Zoom);
end;

end.
