unit g_cfg;

interface
uses
  g_Utils;

function Cfg_ReadInt(FileName, Ident : string; Default: integer) : integer;
function Cfg_ReadStr(FileName, Ident, Default : string) : string;

implementation

function Cfg_ReadInt;
begin
  Result := StrToInt(Cfg_ReadStr(FileName, Ident, IntToStr(Default)));
end;

function Cfg_ReadStr;
var
  f : TextFile;
  buf : string;
  com : string;
begin
  Result := Default;
  AssignFile(f, FileName);
  Reset(f);
  while not EOF(f) do
  begin
    ReadLn(f, buf);
    com := SplitString('=', buf);
    if com = Ident then
    begin
      Result := buf;
      break;
    end;
  end;
  CloseFile(f);
  if Result = '' then
    Result := Default;
end;

end.

