unit g_gui;

interface
uses
  HGE,HGESprite,HGEFont,HGEParticle,
  g_Types,g_Hint,g_Options,g_cfg,g_math,
  g_bonus,g_Player;

type
  TGUI = class
    Fnt,FntWiner : IHGEFont;
    PauseTex,HealthTex : ITexture;
    PauseSpr,HealthSpr : IHGESprite;
    Hint,GamePlayHint,HintLevelName : THint;
    constructor Create;
    procedure Init;
    procedure GameRender;
  end;

var GUI : TGUI;

implementation
uses
  g_Game;

Constructor TGUI.Create;
begin
  inherited;
  Fnt := THGEFont.Create(Cfg_ReadStr('data\cfg\gui.cfg','FONT','data\fonts\default.fnt'));
  FntWiner := THGEFont.Create(Cfg_ReadStr('data\cfg\gui.cfg','FONT_WINER','data\fonts\LevelName.fnt'));
  Hint := THint.Create('data\fonts\default.fnt');
  GamePlayHint := THint.Create('data\fonts\default.fnt');
  Hint.Init;
  GamePlayHint.Init;
  GamePlayHint.SpdY := -1;
  HintLevelName := THint.Create('data\fonts\LevelName.fnt');
  HintLevelName.Init;
  HintLevelName.SpdY := 0;
  HintLevelName.Delay := 2;
  HintLevelName.levelling := 2;
  PauseTex := _HGE.Texture_Load(Cfg_ReadStr('data\cfg\gui.cfg','TEXTURE_PAUSE','pause.png'));
  PauseSpr := THGESprite.Create(PauseTex,0,0,PauseTex.GetWidth,PauseTex.GetHeight);
  PauseSpr.SetHotSpot(PauseTex.GetWidth / 2,PauseTex.GetHeight / 2);
  HealthTex := _HGE.Texture_Load(Cfg_ReadStr('data\cfg\gui.cfg','TEXTURE_HEALTH','pause.png'));
  HealthSpr := THGESprite.Create(HealthTex,0,0,HealthTex.GetWidth,HealthTex.GetHeight);
end;

procedure TGUI.Init;
begin
  Hint.Clear;
  GamePlayHint.Clear;
  HintLevelName.Clear;
end;

procedure TGUI.GameRender;
begin
  if Options.ShowFps then begin
    Fnt.SetColor($ffFF8833);
    Fnt.PrintF(WND_WIDTH,WND_HEIGHT-20,HGETEXT_RIGHT,'FPS:%d',[_HGE.Timer_GetFPS]);
  end;
  //ScorePanelSpr.RenderStretch(WND_WIDTH-12*16,0,WND_WIDTH,6*32);
  //ClockSpr.Render(0,0);
  //----------------------------------------------------------------------------
  // Game info
  //----------------------------------------------------------------------------
  if LevelManager.isPlaying and Game.Pause then begin
    PauseSpr.Render(SCR_CENTER_W,SCR_CENTER_H);
  end;
  HealthSpr.SetColor($ffff0000);
  HealthSpr.RenderEx(20*WndAspect,WND_HEIGHT-30*WndAspect,0,WndAspect,1*WndAspect);
  if Player.Life > 0 then begin
    HealthSpr.SetColor($ff55ccff);
    HealthSpr.RenderEx(20*WndAspect,WND_HEIGHT-30*WndAspect,0,Player.Life/100*WndAspect,1*WndAspect);
  end;

  // Render Score
  Profile.Render;

  BonusManager.RenderGUI;
  if LevelManager.Finish then begin
    FntWiner.SetColor($ff55ccff);
    if LevelManager.Winner then begin
     FntWiner.PrintF(SCR_CENTER_W,SCR_CENTER_H,HGETEXT_CENTER,'Winner',[]);
     Fnt.SetColor($ff55ffcc);
     Fnt.PrintF(SCR_CENTER_W,SCR_CENTER_H+70*WndAspect,HGETEXT_CENTER,
                 '   .'
                 +#13+'  %d .'
                 +#13+'  ,       ...'
                 +#13+'        .'
                 +#13+'  Soulghai  Ignis'
                 +#13+' ,  !!!',[Profile.tScore]);
    end else begin
     FntWiner.PrintF(SCR_CENTER_W,SCR_CENTER_H,HGETEXT_CENTER,'GAME OVER',[]);
    //FntWiner.SetColor($ffff0088);
    //FntWiner.PrintF(SCR_CENTER_W,SCR_CENTER_H,HGETEXT_CENTER,'Score : %d',[Profile.Score]);
     Fnt.SetColor($ff55ccff);
     Fnt.PrintF(SCR_CENTER_W,SCR_CENTER_H+70*WndAspect,HGETEXT_CENTER,' ,     =)',[]);
    end;
  end;
  GamePlayHint.Draw;
  HintLevelName.Draw;
  //_HGE.Input_GetMousePos(X,Y);
  //CursorSpr.RenderEx(X,Y,CursorAngle*deg2rad);
  //if particle<>nil then
    //particle.MoveTo(X+32*WndAspect*cos((CursorAngle+45)*deg2rad),Y+32*WndAspect*sin((CursorAngle+45)*deg2rad));
  //Hint.Draw;
end;

end.
