unit g_Gun_Rocket;

interface
uses
  Windows,Classes,
  HGE,HGESprite,HGEParticle,
  g_Types,g_cfg,g_math,g_Options;

type
  TBullet= class
    X,Y : Single;
    particle : IHGEParticleSystem;
    active : boolean;
  end;

  TGunRocket = class
   public
     X,Y : single;
     inShot : boolean;
     Damage_Time  : single;
     Damage_Delay : single;
     Tex : ITexture;
     Spr : IHGESprite;
     TexParticle : ITexture;
     List : TList;
     Angle : single;
     FireDemage : word;                                                         //  
     DamageRadius : word;                                                       //   
     ReloadTime : single;                                                       //  
     ReloadDelay : single;                                                      //   
     BulletSpeed : single;                                                      //  
     Color : Cardinal;
     sndFire : IEffect;
   public
    constructor Create;
    destructor Destroy;
    procedure Init;
    procedure Shot;
    procedure Render();
    procedure Update(const delta,_X,_Y : single);
    procedure AddBullet(const _X,_Y : single);
    procedure Dead(id : word);
    procedure RocketBoom(id : word);
  end;

implementation
uses
  g_Player,g_monster_fly,g_monster_eye,g_monster_nlo,g_monster_bee,
  g_boss_BigHead;

constructor TGunRocket.Create;
var
  FileName : string;
begin
  inherited;
  FileName := 'data\cfg\gun_Rocket.cfg';
  Tex := _HGE.Texture_Load(Cfg_ReadStr(FileName,'TEXTURE_BULLET','bullet.png'));
  Spr := THGESprite.Create(Tex,0,0,Tex.GetWidth,Tex.GetHeight);
  Spr.SetHotSpot(Tex.GetWidth / 2,Tex.GetHeight / 2);
  Color := $ffffffff;
  Spr.SetColor(Color);
  TexParticle := _HGE.Texture_Load(Cfg_ReadStr(FileName,'TEXTURE_PARTICLE','particles.png'));
  List := TList.Create;
  Angle := 270;
  BulletSpeed := Cfg_ReadInt(FileName,'BULLET_SPEED',6)*WndAspect;
  FireDemage := Cfg_ReadInt(FileName,'FIRE_DAMAGE',5);
  ReloadDelay := Cfg_ReadInt(FileName,'RELOAD_DELAY',10)/100;
  DamageRadius := 128;
  sndFire := _HGE.Effect_Load(Cfg_ReadStr('data\cfg\gun_rocket.cfg','SOUND_FIRE','rocket_fire.wav'));
end;

destructor TGunRocket.Destroy;
begin
  sndFire := nil;
  inherited;
end;

procedure TGunRocket.Init;
begin
  inShot := false;
  //sndFire := SoundEngine.LoadSound(dir_local+Cfg_ReadStr(FileName,'sndFire','data\snd\default.wav'));
  List.Clear;
end;

procedure TGunRocket.Shot;
begin
  if Player.level > 4 then begin
    AddBullet(X-45*WndAspect,Y);
    AddBullet(X+45*WndAspect,Y);
    sndFire.PlayEx(Options.SoundVolume);
  end;
end;

procedure TGunRocket.AddBullet(const _X,_Y : single);
var
 id : integer;
 i : word;
begin
  id := -1;
  i:=0;
  while i<List.Count do begin
    with TBullet(List.Items[i]) do begin
      if not active then begin
        ID := i;
        break;
      end;
    end;
    inc(i);
  end;

  if id = -1 then id := List.Add(TBullet.Create);
  with TBullet(List.Items[id]) do begin
    X := _X;
    Y := _Y;
    active := true;
  end;
end;

procedure TGunRocket.Dead(id : word);
begin
  TBullet(List.Items[id]).active := false;
end;

procedure TGunRocket.RocketBoom(id : word);
var
  i : word;
begin
  //        
  //    DamageDist
  //     
  With TBullet(List.Items[id]) do begin
  i:=0;
  while i<Monsters_FLY.List.Count do begin
    if TMonster_FLY(Monsters_FLY.List.Items[i]).Life > 0 then
    if Distance2D(X,Y,TMonster_FLY(Monsters_FLY.List.Items[i]).X,TMonster_FLY(Monsters_FLY.List.Items[i]).Y)< DamageRadius then begin
      Monsters_FLY.Damage(i,FireDemage);
      //MonsterMan.Dead(i);
      //continue;
    end;
    inc(i);
  end;
  if TBullet(List.Items[id]).active then begin
    i:=0;
    while i<Monsters_EYE.List.Count do begin
      if TMonster(Monsters_EYE.List.Items[i]).Life > 0 then
      if Distance2D(X,Y,TMonster(Monsters_EYE.List.Items[i]).X,TMonster(Monsters_EYE.List.Items[i]).Y)< DamageRadius then begin
        Monsters_EYE.Damage(i,FireDemage);
      end;
      inc(i);
    end;
  end;
  if TBullet(List.Items[id]).active then begin
    i:=0;
    while i<Monsters_NLO.List.Count do begin
      if TMonster(Monsters_NLO.List.Items[i]).Life > 0 then
      if Distance2D(X,Y,TMonster(Monsters_NLO.List.Items[i]).X,TMonster(Monsters_NLO.List.Items[i]).Y)< DamageRadius then begin
        Monsters_NLO.Damage(i,FireDemage);
      end;
      inc(i);
    end;
  end;
  if active then begin
    i:=0;
    while i<Monsters_BEE.List.Count do begin
      if TMonster_BEE(Monsters_BEE.List.Items[i]).Life > 0 then
      if Distance2D(X,Y,TMonster_BEE(Monsters_BEE.List.Items[i]).X,TMonster_BEE(Monsters_BEE.List.Items[i]).Y)<DamageRadius then begin
        Monsters_BEE.Damage(i,FireDemage);
        break;
      end;
    inc(i);
  end;
  end;
  if Boss_BigHead.Life > 0 then begin
    if TBullet(List.Items[id]).active then
    if Boss_BigHead.Life > 0 then
    if Distance2D(X,Y,Boss_BigHead.X,Boss_BigHead.Y) < DamageRadius then
      Boss_BigHead.Damage(FireDemage);
    if TBullet(List.Items[id]).active then
    if Boss_BigHead.Hand[0].Life > 0 then
    if Distance2D(X,Y,Boss_BigHead.Hand[0].X,Boss_BigHead.Hand[0].Y) < DamageRadius then
      Boss_BigHead.Hand[0].Damage(FireDemage,Boss_BigHead.SndDead);
    if TBullet(List.Items[id]).active then
    if Boss_BigHead.Hand[1].Life > 0 then
    if Distance2D(X,Y,Boss_BigHead.Hand[1].X,Boss_BigHead.Hand[1].Y) < DamageRadius then
      Boss_BigHead.Hand[1].Damage(FireDemage,Boss_BigHead.SndDead);
    end;
  end;

  ToggleParSys(TBullet(List.Items[id]).Particle,'data\particles\particle_gun_rocket.psi',TexParticle,32,32,32,
               round(TBullet(List.Items[id]).X),round(TBullet(List.Items[id]).Y),
               BLEND_ALPHABLEND or BLEND_COLORMUL or BLEND_ALPHAADD,$ffffff00,$ffff0000);
  Dead(id);
end;

procedure TGunRocket.Update(const delta,_X,_Y : single);
var i,j : word;
begin
  X := _X;
  Y := _Y;
  ReloadTime := ReloadTime + delta;
  if (inShot)and(ReloadTime > ReloadDelay) then begin
    Shot;
    inShot := false;
    ReloadTime := 0;
  end else inShot := false;

  i:=0;
  while i<List.Count do begin
    if TBullet(List.Items[i]).active then
    with TBullet(List.Items[i]) do begin
      X := X + BulletSpeed*cos(deg2rad*Angle);
      Y := Y + BulletSpeed*sin(deg2rad*Angle);
      if Y < 0 then Dead(i) else begin
        j:=0;
        while j<Monsters_FLY.List.Count do begin
          if TMonster_FLY(Monsters_FLY.List.Items[j]).Life > 0 then
          if Distance2D(X,Y,TMonster_FLY(Monsters_FLY.List.Items[j]).X,TMonster_FLY(Monsters_FLY.List.Items[j]).Y)< Monsters_FLY.Radius then begin
            RocketBoom(i);
            break;
          end;
          inc(j);
        end;
        if active then begin
          j:=0;
          while j<Monsters_EYE.List.Count do begin
            if TMonster(Monsters_EYE.List.Items[j]).Life > 0 then
            if Distance2D(X,Y,TMonster(Monsters_EYE.List.Items[j]).X,TMonster(Monsters_EYE.List.Items[j]).Y)<Monsters_EYE.Radius then begin
              RocketBoom(i);
              break;
            end;
            inc(j);
          end;
        end;
        if active then begin
          j:=0;
          while j<Monsters_NLO.List.Count do begin
            if TMonster(Monsters_NLO.List.Items[j]).Life > 0 then
            if Distance2D(X,Y,TMonster(Monsters_NLO.List.Items[j]).X,TMonster(Monsters_NLO.List.Items[j]).Y)<Monsters_NLO.Radius then begin
              RocketBoom(i);
              break;
            end;
            inc(j);
          end;
        end;
        if active then begin
          j:=0;
          while j<Monsters_BEE.List.Count do begin
            if TMonster_BEE(Monsters_BEE.List.Items[j]).Life > 0 then
            if Distance2D(X,Y,TMonster_BEE(Monsters_BEE.List.Items[j]).X,TMonster_BEE(Monsters_BEE.List.Items[j]).Y)<Monsters_BEE.Radius then begin
              RocketBoom(i);
              break;
            end;
          inc(j);
          end;
        end;
        if Boss_BigHead.Life > 0 then begin
          if active then begin
            if Boss_BigHead.Life > 0 then
            if Distance2D(X,Y,Boss_BigHead.X,Boss_BigHead.Y)<Boss_BigHead.Radius then begin
              Boss_BigHead.Damage(FireDemage);
              RocketBoom(i);
              break;
            end;
          end;
          if active then begin
            if Boss_BigHead.Hand[0].Life > 0 then
            if Distance2D(X,Y,Boss_BigHead.Hand[0].X,Boss_BigHead.Hand[0].Y)<Boss_BigHead.Hand[0].Radius then begin
              Boss_BigHead.Hand[0].Damage(FireDemage,Boss_BigHead.SndDead);
              RocketBoom(i);
              break;
            end;
          end;
          if active then begin
            if Boss_BigHead.Hand[1].Life > 0 then
            if Distance2D(X,Y,Boss_BigHead.Hand[1].X,Boss_BigHead.Hand[1].Y)<Boss_BigHead.Hand[1].Radius then begin
              Boss_BigHead.Hand[1].Damage(FireDemage,Boss_BigHead.SndDead);
              RocketBoom(i);
              break;
            end;
          end;
        end;
      end;
    end;
    inc(i);
  end;
end;

procedure TGunRocket.Render();
var i : word;
begin
  i := 0;
  while i < List.Count do begin
    if TBullet(List.Items[i]).active then
    with TBullet(List.Items[i]) do
      Spr.RenderEx(X,Y,deg2rad*Angle,1.5*WndAspect);
  inc(i);
  end;
end;

end.
