unit g_gun_voice;

interface
uses
  Windows, 
  HGE,HGESprite,HGEParticle,
  g_Types,g_cfg,g_math;

type
  TGunVoice = class
    X,Y : single;
    inShot : boolean;
    FireDemage : single;                                                       //  
    ReloadTime : single;                                                       //  
    ReloadDelay : single;                                                      //   
    Damage_Time  : single;
    Damage_Delay : single;
    Fire : boolean;
    Tex : ITexture;
    Spr : IHGESprite;
    TexParticle : ITexture;
    constructor Create;
    procedure Init;
    procedure Shot;
    procedure Update(const delta : single;const _X,_Y : single);
    procedure Render;
  end;

implementation
uses
  g_Player;

constructor TGunVoice.Create();
var FileName : string;
begin
  Inherited;
  FileName := 'data\cfg\gun_voice.cfg';
  Tex := _HGE.Texture_Load(Cfg_ReadStr(FileName,'TEXTURE_BULLET','bullet.png'));
  Spr := THGESprite.Create(Tex,0,0,Tex.GetWidth,Tex.GetHeight);
  Spr.SetColor($ffffffff);
  Spr.SetHotSpot(Tex.GetWidth / 2,Tex.GetHeight / 2);
  TexParticle := _HGE.Texture_Load(Cfg_ReadStr(FileName,'TEXTURE_PARTICLE_BALL','particles.png'));
  Damage_Delay := Cfg_ReadInt(FileName,'DAMAGE_DELAY',5)/10;
  FireDemage := Cfg_ReadInt(FileName,'FIRE_DAMAGE',5);
  ReloadDelay := Cfg_ReadInt(FileName,'RELOAD_DELAY',10)/100;
  Fire:= false;
  Damage_Time := 0;
end;

procedure TGunVoice.Init;
begin
  //sndFire := SoundEngine.LoadSound(dir_local+Cfg_ReadStr(FileName,'sndFire','data\snd\default.wav'));
  inShot := false;
end;

procedure TGunVoice.Shot;
begin
  if Player.Level > 5 then begin
    Fire := true;
    Damage_Time :=0;
  end;
end;

procedure TGunVoice.Update(const delta : single;const _X,_Y : single);
var i : word;
begin
  X := _X;
  Y := _Y;
  ReloadTime := ReloadTime + delta;
  if (inShot)and(ReloadTime > ReloadDelay) then begin
    Shot;
    inShot := false;
    ReloadTime := 0;
  end else inShot := false;

  if Fire then begin
    Damage_Time := Damage_Time + delta;
    if Damage_Time > Damage_Delay then begin
      Fire := false;
      ReloadTime := 0;
    end;
  end;
  {i:=0;
  while i<BulletMan.List.Count do begin
    with TBullet(BulletMan.List.Items[i]) do begin
      X := X + BulletMan.BulletSpeed*cos(deg2rad*Angle);
      Y := Y + BulletMan.BulletSpeed*sin(deg2rad*Angle);
      if Y < 0 then BulletMan.Dead(i) else begin
        {for i := 0 to FIELD_SIZE do
          for m := 0 to FIELD_SIZE do begin
          if FieldMan.Field[i,m].Visual then
          if 12*WndAspect > Distance2D(X,Y,FieldMan.Field[i,m].X,FieldMan.Field[i,m].Y) then begin
            SetMovePos(FieldMan.Field[i,m].X,FieldMan.Field[i,m].Y);
            Stop;
            for k := 0 to List.Count - 1 do
              if (k<>j)and(distance2d(X,Y,TBall(List.Items[k]).X,TBall(List.Items[k]).Y)<12*WndAspect) then begin
                TBall(List.Items[k]).Free;
                List.Delete(k);
                break;
              end;
            if Game.GameplayColorAll[FieldMan.Field[i,m].mood] = Color
             then begin
               FieldMan.MakeBusy(i,m);
               inc(Profile.tScore,300);
               gui.GamePlayHint.Add(X,Y,'+300',Color);
             end else begin
               dec(Profile.tScore,100);
               gui.GamePlayHint.Add(X,Y,'-100',Color);
             end;
            break;
          end;
         end;
        end;
      end;
    inc(i);
  end;    }
end;

procedure TGunVoice.Render();
begin
  if Fire then begin
    Spr.RenderEx(X,Y,0,3*WndAspect);
  end;
end;

end.
