unit S_Dura; //     

interface
uses
  Omega, S_materials;

type
  T_TDura = record  //  
    Speed : single;
    Live  : word;   //   .
    Power : byte;   //   .
  end;

  T_Dura = record   // 
    X, Y,           //   
    Speed : single;
    Live  : word;   //   .
    T     : byte;   //  / 
    Enabled : boolean;
  end;

  T_PDura = record    //   
    X, Y,             //   
    LiveA : single;   // .
    T     : byte;     //  / 
    S     : shortint;
  end;

var
  TDura : array[1..2] of T_TDura;
  Dura  : array       of T_Dura;
  PDura : array       of T_PDura;

procedure Init;
procedure Fire(X, Y : single; T : byte; pX : shortint);  //  
procedure Work;
procedure Draw;

implementation
uses
  S_map, S_game, S_ai, Live;

procedure Init;
begin
  TDura[1].Speed:=8;
  TDura[1].Live :=500;
  TDura[1].Power:=5;
end;

procedure Fire(X, Y : single; T : byte; pX : shortint);  //  
var
  J, I : integer;
begin
  I:=-1;
  for J:=0 to length(Dura)-1 do
  if not Dura[J].Enabled then
    begin
      I:=J;
      Break;
    end;
  if I=-1 then
    begin
      I:=length(Dura);
      SetLength(Dura, I+1);
    end;

  Dura[I].Speed:=pX*TDura[T].Speed;

  Dura[I].Y:=Y;
  Dura[I].X:=X+Dura[I].Speed;

  Dura[I].T:=T;
  Dura[I].Live:=TDura[T].Live;
  Dura[I].Enabled:=True;
end;

procedure Work;
var
  I, I2 : integer;
  kX, kY : word;
begin
  for I:=0 to length(Dura)-1 do
  with Dura[I] do
  if Enabled then
    begin
      X:=X+Speed;
      Dec(Live);
      
      kX:= round( X+S_map.Ed_X        )  div S_map.Ed_X-1;
      kY:= round( Y+S_Map.Ed_Y        )  div S_map.Ed_Y-1;

      if (Live<1) or (X<0) or(kX>Map.MofKlX) or (Map.Kl[kX, kY].T in [clip, clip2]) then
      Enabled:=false
      else
      for I2:=0 to Map.MofBot-1 do
        if  (BotP2[I2].Live>10)
        and (X>Map.Bot[I2].X+8)
        and (X<Map.Bot[I2].X+120)
        and (Y>Map.Bot[I2].Y+4)
        and (Y<Map.Bot[I2].Y+60)
        then
          begin
            Enabled:=false;
            BotP2[I2].Animation:=4;
            dec(BotP2[I2].Live, TDura[T].Power);
            if (BotP2[I2].Live<=10) then
            BotP2[I2].Animation:=6;
            BotP2[I2].AnimationN:=1;
          end;
      if Enabled then
        if  (HeroP2.Animation<>16)
        and (not((HeroP2.Animation=14) and (HeroP2.AnimationN>8)))
        and (X>Map.Hero.X+40)
        and (X<Map.Hero.X+88)
        and (Y>Map.Hero.Y+4)
        and (Y<Map.Hero.Y+124)
        then
          begin
            Enabled:=false;
            if HeroP2.Live-TDura[T].Power<=11 then
                        begin
              HeroP2.Animation:=16;
              HeroP2.AnimationPr:=16;
              HeroP2.AnimationN:=1;
              HeroP2.PrV:=0.25;
              HeroP2.Pr:=true;
              //HeroP2.Live:=8
            end
            //HeroP2.Live:=11
            else
            dec(HeroP2.Live, TDura[T].Power)
          end;
    end;

end;

procedure Draw;
var
  I, Flag : integer;
begin
  for I:=0 to length(Dura)-1 do
  with Dura[I] do
  if Enabled then
  begin
  if Speed<0 then Flag:=FX_DEFAULT or FX_FLIPX
  else Flag:=1;
  if (X-CameraX>=0) and (X-CameraX<=1024) then
  Omega.SSprite_Draw(S_materials.TTMD[1], Dura[I].X-CameraX, Dura[I].Y-CameraY, 8, 8, 255, 0, Flag);

  end;
end;

end.
