unit S_game;

interface
uses
  Omega, MScenes, S_ai,
  Setup, S_Dura;

  {
   1 : 
   2 : 
   3 :   
   4 :   
   5 :
  }

var
  HeroP2  : TpersP2;
  HeroT   : array[1..2] of TTPers;
  LevelN  : string;   //  
  ProfyS  : string;
  Hero_WH : single;
  Hero_Al : byte;
  ChLevel : boolean = false; //  

  CameraX, CameraY : single; // - 

procedure Init;
procedure Draw;
procedure Work;
procedure LoadLevel(LN : string = '');
procedure NewLevel (LN : string = '');

implementation
uses
  Live, S_map, S_materials, S_Scripts,  LexUtils;

//____ INIT!!!
procedure Init;
begin
    Live.kX:=0;
    Live.kY:=0;
  //  
    HeroP2.Animation  :=1;
    HeroP2.AnimationN :=1;
    HeroP2.Pr         :=false;
    HeroP2.Left       :=false;
    HeroP2.Shift      :=false;
    HeroP2.F          :=true;
    HeroP2.Live       :=110;

    HeroT[1].CRun     :=true;
    HeroT[1].CClimb   :=true;
    HeroT[1].CFire    :=false;
    HeroT[1].CUp      :=false;
    HeroT[1].Spd      :=2;
    HeroT[1].MofT[1]  :=8;
    HeroT[1].MofT[2]  :=31;
    HeroT[1].MofT[3]  :=31;
    HeroT[1].MofT[4]  :=1;
    HeroT[1].MofT[5]  :=1;
    HeroT[1].MofT[6]  :=8;
    HeroT[1].MofT[7]  :=8;

    HeroT[1].MofT[9]  :=16;
    HeroT[1].MofT[10] :=16;
    HeroT[1].MofT[11] :=16;
    HeroT[1].MofT[12] :=16;
    HeroT[1].MofT[14] :=16;
    HeroT[1].MofT[16] :=32;
    HeroT[1].MofT[17] :=16;
    HeroT[1].MofT[18] :=30;

    HeroT[1].Gun_pY   :=45;
    HeroT[1].T_Gun    :=1;
    HeroT[2]          :=HeroT[1];
    HeroT[2].CFire    :=true;


    Hero_WH  :=128;
    Hero_AL  :=255;
  //_____

  //  

  with BotT[1] do
    begin
      CRun     :=true;
      CClimb   :=true;
      CFire    :=true;
      CUp      :=false;
      Spd      :=1;
      MofT[1]  :=32;
      MofT[2]  :=32;
      MofT[3]  :=32;
      MofT[4]  :=16;
      MofT[5]  :=8;
      MofT[6]  :=8;
      Gun_pY   :=25;
    end;

  ChLevel:=false;


end;
//_____

//_____ DRAW!!!
procedure Draw;
begin
  S_map.Draw;
  Omega.SSprite_Draw(S_materials.TBar, 6, 6, 320, 40, 210);
  Omega.Text_Draw(S_materials.FontA1, 12, 12, PChar( ': ' + U_IntToStr( HeroP2.Live-11)));
  Omega.Text_Draw(S_materials.FontA1, 12, 50, PChar( 'FPS: ' + U_IntToStr( OE_GetFPS)), 1, 0, 255{, 0});

end;
//_____
procedure LoadLevel(LN : string = ''); //  
begin
  S_game.Init;
  if LN<>'' then LevelN:=LN;
  S_map.Open(LevelN+'.lex');
  S_Scripts.Open(LevelN+'.txt');
end;

procedure NewLevel(LN : string = '');  //  
begin
  ChLevel:=true;
  if LN<>'' then LevelN:=LN;
  S_map.Map.Hero.X:=kX*Ed_X-16-8;
  S_map.Map.Hero.Y:=kY*Ed_Y-5;
end;

// Work Proc's
procedure GameOver;
begin
  MScenes.NewScn(1, 47);
end;

//_____ WORK!!!
procedure Work;
var
  pX, pY : shortint;
//  lpX, lpY : single;
begin
  S_map.Work;
   
  pX:=0;
  pY:=0;
  //  
  if Omega.Key_Down(UK_up   ) then dec(pY);
  if Omega.Key_Down(UK_down ) then inc(pY);
  if Omega.Key_Down(UK_left ) then dec(pX);
  if Omega.Key_Down(UK_right) then inc(pX);
  if Omega.Key_Down(UK_shift) then HeroP2.Shift:=true    //  
                              else HeroP2.Shift:=false;

  if Omega.Key_Down(UK_E) then HeroP2.HG:=true          //  HoleGun
                          else HeroP2.HG:=false;

  if ChLevel then //  
    begin
      MScenes.NewScn(1, 47);
    end
  else
  Live.Move(pX, pY, HeroT[1], map.Hero, HeroP2 );  // 

  //  :
  if ( Live.kX<32) and (Live.kY<16)
  and (S_map.Map.Kl[kX, kY].ScH>0) then
  S_scripts.WorkHero(S_scripts.SScr[S_map.Map.Kl[kX, kY].ScH - 1]);
  // ____
  if (HeroP2.Animation=16) and (HeroP2.AnimationN>=HeroT[1].MofT[16]-1)
  then
  HeroP2.Live:=10;
 // else //     
  if HeroP2.Live<=10 then GameOver;

  if Key_Down( K_ESCAPE ) Then MScenes.NewScn(45);

  S_ai.Work;
  S_Dura.Work; //  


  if (Map.Hero.Y>CameraY+512)
  then
  CameraY:=Map.Hero.Y-512
  else
  if (Map.Hero.Y<CameraY+256)
  then
  CameraY:=Map.Hero.Y-256;

  if (Map.Hero.X>CameraX+768)
  then
  CameraX:=Map.Hero.X-768
  else
  if (Map.Hero.X<CameraX+256)
  then
  CameraX:=Map.Hero.X-256;

  if CameraY>768 then CameraY:=768;
  if CameraX<0 then CameraX:=0;

 { if (lpX>0) and (Map.Hero.X>Camera.X+768) then
  Camera^.X:=Camera^.X -lpX
  else
  if (Map.Hero.X<Camera.X+256) then
  Camera^.X:=Camera^.X -lpX;

  if (lpY<0) and (Map.Hero.Y>Camera.Y+512) then
  Camera^.Y:=Camera^.Y -lpY
  else
  if (Map.Hero.Y<Camera.Y+128) then
  app(Camera^.Y, -lpY);}
end;
//____

end.
