unit BR_materials;

interface
uses
  Omega;

type

  TTcord = record
    pX, pY, sH, sW, H, W : integer;
    N, M, UN : string[250];
    useM : boolean;
    T : byte;
  end;

const
    A_b = 1;
    A_l = 2;
    A_f = 3;
    A_s = 4;
    A_o = 5;
    A_t = 6;
    A_r = 7;

type
  TTData = record
    CA  : array[A_b..A_r] of array[1..100] of TTcord;
    Mof : array[A_b..A_r] of byte;
  end;


var
  FontA1 : Omega.PFONT2D; //  
  THero : array[1..20] of Omega.PTexture;
  TBot  : array[1..10] of Omega.PTexture;
  
  TA : array[A_b..A_r] of array of Omega.PTexture;
  TData   : TTData;

  TTMD  : array[0..2] of Omega.PTexture;
  TTMSD : array[0..2] of Omega.PTexture;
  TBar  : Omega.PTexture;
procedure Save(FN : string);
procedure Open(FN : string);
procedure Load;
procedure LoadM(iT, N : byte; iM : TTcord);

implementation

procedure LoadM(iT, N : byte; iM : TTcord);
var
  Flag  : integer;
  S : string;
begin
  if iM.useM then
    begin
      S:=iM.M;
      Tex_LoadMaskFromFile(PChar(S));
      Flag:=TEX_DEFAULT_2D or TEX_USEMASK;
    end
  else
  Flag:=0;
  S:=iM.N;
  TA[iT][N]:=Tex_LoadFromFile(PChar(S), -1, Flag);
  if iM.T>0 then
  Omega.Tex_SetFramesSize(TA[iT][N], iM.sW, iM.sH);

end;

procedure Save(FN : string);
var
  F : File;
  I, I1 : integer;
begin
  assignfile(F, FN);
  rewrite(F, 1);
  for I:=1 to 7 do
    begin
      //  :
      BlockWrite( F, TData.Mof[I], SizeOf( Integer ) );
      // :
      for I1:=1 to  TData.Mof[I] do
      BlockWrite( F, TData.CA[I][I1],  SizeOf( TTcord ) );
    end;
  closefile(F);
end;

procedure Open(FN : string);
var
  F : File;
  I, I1 : integer;
begin
  Load;
  assignfile(F, FN);
  reset(F, 1);
  for I:=1 to 7 do
    begin
      //  :
      BlockRead( F, TData.Mof[I], SizeOf( Integer ) );
      // :
      for I1:=1 to TData.Mof[I] do
      BlockRead( F, TData.CA[I][I1],  SizeOf( TTcord ) );
    end;
  closefile(F);

  for I:=1 to 7 do
    begin
      SetLength(TA[I], TData.Mof[I]+1);
      for I1:=1 to TData.Mof[I] do
      LoadM(I, I1, TData.CA[I][I1]);
    end;
end;

procedure Load;
var
  I : integer;
begin

  for I:=1 to 7 do
  begin
    setlength(TA[I], 1);
    TA[I][0]:=Tex_LoadFromFile(PChar('Data\eror.jpg'), -1, 0);
    TData.Mof[I]:=0;
  end;
  TBar:=Tex_LoadFromFile(PChar('Data\dialog.jpg'), -1, TEX_DEFAULT_2D);
  
  Tex_LoadMaskFromFile(PChar('Data\td1m.gif'));
  TTMD[1]:=Tex_LoadFromFile(PChar('Data\td1.gif'), -1, TEX_DEFAULT_2D or TEX_USEMASK);

  //   
  Tex_LoadMaskFromFile(PChar('Data\Hero\j_sm.gif'));
  THero[1]:=Tex_LoadFromFile(PChar('Data\Hero\j_s.jpg'), -1, TEX_DEFAULT_2D or TEX_USEMASK);
  Omega.Tex_SetFramesSize(THero[1], 128, 128);
  
  Tex_LoadMaskFromFile(PChar('Data\Hero\j_wm.gif'));
  THero[2]:=Tex_LoadFromFile(PChar('Data\Hero\j_w.jpg'), -1, TEX_DEFAULT_2D or TEX_USEMASK);
  Omega.Tex_SetFramesSize(THero[2], 128, 128);

  Tex_LoadMaskFromFile(PChar('Data\Hero\j_rm.gif'));
  THero[3]:=Tex_LoadFromFile(PChar('Data\Hero\j_r.jpg'), -1, TEX_DEFAULT_2D or TEX_USEMASK);
  Omega.Tex_SetFramesSize(THero[3], 128, 128);

  Tex_LoadMaskFromFile(PChar('Data\Hero\j_jrm.gif'));
  THero[4]:=Tex_LoadFromFile(PChar('Data\Hero\j_jr.jpg'), -1, TEX_DEFAULT_2D or TEX_USEMASK);
  Omega.Tex_SetFramesSize(THero[4], 128, 128);

  Tex_LoadMaskFromFile(PChar('Data\Hero\j_jfm.gif'));
  THero[5]:=Tex_LoadFromFile(PChar('Data\Hero\j_jf.jpg'), -1, TEX_DEFAULT_2D or TEX_USEMASK);
  Omega.Tex_SetFramesSize(THero[5], 128, 128);

  Tex_LoadMaskFromFile(PChar('Data\Hero\j_upm.gif'));
  THero[6]:=Tex_LoadFromFile(PChar('Data\Hero\j_up.jpg'), -1, TEX_DEFAULT_2D or TEX_USEMASK);
  Omega.Tex_SetFramesSize(THero[6], 128, 128);

  Tex_LoadMaskFromFile(PChar('Data\Hero\j_upfm.gif'));
  THero[7]:=Tex_LoadFromFile(PChar('Data\Hero\j_upf.jpg'), -1, TEX_DEFAULT_2D or TEX_USEMASK);
  Omega.Tex_SetFramesSize(THero[7], 128, 128);

  Tex_LoadMaskFromFile(PChar('Data\Hero\j_tsm.gif'));
  THero[9]:=Tex_LoadFromFile(PChar('Data\Hero\j_ts.jpg'), -1, TEX_DEFAULT_2D or TEX_USEMASK);
  Omega.Tex_SetFramesSize(THero[9], 128, 128);

  Tex_LoadMaskFromFile(PChar('Data\Hero\j_tlm.gif'));
  THero[10]:=Tex_LoadFromFile(PChar('Data\Hero\j_tl.jpg'), -1, TEX_DEFAULT_2D or TEX_USEMASK);
  Omega.Tex_SetFramesSize(THero[10], 128, 128);

  Tex_LoadMaskFromFile(PChar('Data\Hero\j_cum.gif'));
  THero[11]:=Tex_LoadFromFile(PChar('Data\Hero\j_cu.jpg'), -1, TEX_DEFAULT_2D or TEX_USEMASK);
  Omega.Tex_SetFramesSize(THero[11], 128, 128);

  Tex_LoadMaskFromFile(PChar('Data\Hero\j_clm.gif'));
  THero[12]:=Tex_LoadFromFile(PChar('Data\Hero\j_cl.jpg'), -1, TEX_DEFAULT_2D or TEX_USEMASK);
  Omega.Tex_SetFramesSize(THero[12], 128, 128);

  Tex_LoadMaskFromFile(PChar('Data\Hero\j_dm.gif'));
  THero[14]:=Tex_LoadFromFile(PChar('Data\Hero\j_d.jpg'), -1, TEX_DEFAULT_2D or TEX_USEMASK);
  Omega.Tex_SetFramesSize(THero[14], 128, 128);

  Tex_LoadMaskFromFile(PChar('Data\Hero\j_diem.gif'));
  THero[16]:=Tex_LoadFromFile(PChar('Data\Hero\j_die.jpg'), -1, TEX_DEFAULT_2D or TEX_USEMASK);
  Omega.Tex_SetFramesSize(THero[16], 128, 128);

  Tex_LoadMaskFromFile(PChar('Data\Hero\j_hm.gif'));
  THero[17]:=Tex_LoadFromFile(PChar('Data\Hero\j_h.jpg'), -1, TEX_DEFAULT_2D or TEX_USEMASK);
  Omega.Tex_SetFramesSize(THero[17], 128, 128);

  Tex_LoadMaskFromFile(PChar('Data\Hero\j_wbm.gif'));
  THero[18]:=Tex_LoadFromFile(PChar('Data\Hero\j_wb.jpg'), -1, TEX_DEFAULT_2D or TEX_USEMASK);
  Omega.Tex_SetFramesSize(THero[18], 128, 128);
  //______________
  Tex_LoadMaskFromFile(PChar('Data\Hunter\stm.gif'));
  TBot[1]:=Tex_LoadFromFile(PChar('Data\Hunter\st.jpg'), -1, TEX_DEFAULT_2D or TEX_USEMASK);
  Omega.Tex_SetFramesSize(TBot[1], 128, 64);

  Tex_LoadMaskFromFile(PChar('Data\Hunter\2.gif'));
  TBot[2]:=Tex_LoadFromFile(PChar('Data\Hunter\2.jpg'), -1, TEX_DEFAULT_2D or TEX_USEMASK);
  Omega.Tex_SetFramesSize(TBot[2], 128, 64);

  Tex_LoadMaskFromFile(PChar('Data\Hunter\3.gif'));
  TBot[3]:=Tex_LoadFromFile(PChar('Data\Hunter\3.jpg'), -1, TEX_DEFAULT_2D or TEX_USEMASK);
  Omega.Tex_SetFramesSize(TBot[3], 128, 64);

  Tex_LoadMaskFromFile(PChar('Data\Hunter\4.gif'));
  TBot[4]:=Tex_LoadFromFile(PChar('Data\Hunter\4.jpg'), -1, TEX_DEFAULT_2D or TEX_USEMASK);
  Omega.Tex_SetFramesSize(TBot[4], 128, 64);

  Tex_LoadMaskFromFile(PChar('Data\Hunter\5.gif'));
  TBot[5]:=Tex_LoadFromFile(PChar('Data\Hunter\5.jpg'), -1, TEX_DEFAULT_2D or TEX_USEMASK);
  Omega.Tex_SetFramesSize(TBot[5], 128, 64);

  Tex_LoadMaskFromFile(PChar('Data\Hunter\6.gif'));
  TBot[6]:=Tex_LoadFromFile(PChar('Data\Hunter\6.jpg'), -1, TEX_DEFAULT_2D or TEX_USEMASK);
  Omega.Tex_SetFramesSize(TBot[6], 128, 64);
  //______________
  Tex_LoadMaskFromFile(PChar('Data\Font1.jpg'));
  FontA1:= Text_LoadFontFromFile( 'Data\Font1.jpg', 'Data\Font1.ofi', 0, TEX_DEFAULT_2D or TEX_USEMASK);

end;

end.
